"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var log_1 = require("app/log");
var services_module_content_1 = require("app/services/services.module.content");
var uri_service_1 = require("app/services/uri-service");
var storage_module_1 = require("app/storage/storage.module");
var app_content_module_1 = require("./app.content.module");
var async_settings_1 = require("./storage/async-settings");
var setting_specs_1 = require("./storage/setting-specs");
var storageReadyPromise = Promise.resolve();
var uriService = new uri_service_1.UriService(log_1.log, "AppContent");
var rpServices = new services_module_content_1.RPContentServices(log_1.log, uriService);
var asyncSettings = new async_settings_1.AsyncSettings(log_1.log, browser.storage, browser.storage.local, setting_specs_1.SETTING_SPECS.defaultValues, storageReadyPromise);
log_1.dAsyncSettings.resolve(asyncSettings);
var storage = new storage_module_1.Storage(log_1.log, asyncSettings, null, storageReadyPromise);
exports.rp = new app_content_module_1.AppContent(log_1.log, rpServices, storage);