"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var module_1 = require("lib/classes/module");
var BrowserSettings = (function (_super) {
    __extends(BrowserSettings, _super);
    function BrowserSettings(log, cachedSettings, networkPrivacyApi) {
        var _this = _super.call(this, "app.browserSettings", log) || this;
        _this.cachedSettings = cachedSettings;
        _this.networkPrivacyApi = networkPrivacyApi;
        return _this;
    }
    Object.defineProperty(BrowserSettings.prototype, "startupPreconditions", {
        get: function () {
            return [
                this.cachedSettings.whenReady,
            ];
        },
        enumerable: true,
        configurable: true
    });
    BrowserSettings.prototype.startupSelf = function () {
        if (this.cachedSettings.get("browserSettings.disablePrefetching")) {
            this.networkPrivacyApi.networkPredictionEnabled.set({ value: false }).catch(this.log.onError("set networkPredictionEnabled false"));
        }
        else {
            this.networkPrivacyApi.networkPredictionEnabled.clear({}).catch(this.log.onError("clear networkPredictionEnabled setting"));
        }
        return Promise.resolve();
    };
    return BrowserSettings;
}(module_1.Module));
exports.BrowserSettings = BrowserSettings;