"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("data/constants");
var module_1 = require("lib/classes/module");
var request_result_1 = require("lib/request-result");
var ruleset_1 = require("lib/ruleset");
exports.RULES_CHANGED_TOPIC = "rpcontinued-rules-changed";
function notifyRulesChanged() {
    Services.obs.notifyObservers(null, exports.RULES_CHANGED_TOPIC, null);
}
var Policy = (function (_super) {
    __extends(Policy, _super);
    function Policy(log, subscriptions, rulesetStorage) {
        var _this = _super.call(this, "app.policy", log) || this;
        _this.subscriptions = subscriptions;
        _this.rulesetStorage = rulesetStorage;
        _this.userRulesets = {};
        _this.addAllowRule = _this.addRule.bind(_this, constants_1.C.RULE_ACTION_ALLOW);
        _this.addTemporaryAllowRule = _this.addTemporaryRule.bind(_this, constants_1.C.RULE_ACTION_ALLOW);
        _this.removeAllowRule = _this.removeRule.bind(_this, constants_1.C.RULE_ACTION_ALLOW);
        _this.addDenyRule = _this.addRule.bind(_this, constants_1.C.RULE_ACTION_DENY);
        _this.addTemporaryDenyRule = _this.addTemporaryRule.bind(_this, constants_1.C.RULE_ACTION_DENY);
        _this.removeDenyRule = _this.removeRule.bind(_this, constants_1.C.RULE_ACTION_DENY);
        _this.addAllowRules = _this.addRules.bind(_this, constants_1.C.RULE_ACTION_ALLOW);
        _this.addDenyRules = _this.addRules.bind(_this, constants_1.C.RULE_ACTION_DENY);
        _this.subscriptions = subscriptions;
        return _this;
    }
    Policy.prototype.getUserRulesets = function () {
        return this.userRulesets;
    };
    Policy.prototype.getUserRuleCount = function () {
        var rawRuleset = this.userRulesets.user.rawRuleset;
        return rawRuleset.getAllowRuleCount() + rawRuleset.getDenyRuleCount();
    };
    Policy.prototype.loadUserRules = function () {
        var _this = this;
        this.log.info("loadUserRules loading user rules");
        var pRawRuleset = this.rulesetStorage.loadRawRulesetFromFile("user");
        var p = pRawRuleset.then(function (aRawRuleset) {
            _this.userRulesetExistedOnStartup = !!aRawRuleset;
            var rawRuleset = aRawRuleset || ruleset_1.RawRuleset.create();
            _this.userRulesets.user = {
                rawRuleset: rawRuleset,
                ruleset: rawRuleset.toRuleset("user"),
            },
                _this.userRulesets.user.ruleset.userRuleset = true;
            _this.revokeTemporaryRules();
            notifyRulesChanged();
            return;
        });
        p.catch(this.log.onError("loadUserRules()"));
        return p;
    };
    Policy.prototype.ruleExists = function (ruleAction, ruleData) {
        this.assertRuleAction(ruleAction);
        for (var name in this.userRulesets) {
            if (this.userRulesets[name].rawRuleset.ruleExists(ruleAction, ruleData)) {
                return true;
            }
        }
        var subscriptionRulesets = this.subscriptions.getRulesets();
        for (var listName in subscriptionRulesets) {
            var rulesets = subscriptionRulesets[listName];
            for (var name in rulesets) {
                if (rulesets[name].rawRuleset.ruleExists(ruleAction, ruleData)) {
                    return true;
                }
            }
        }
        return false;
    };
    Policy.prototype.addRule = function (ruleAction, ruleData, noStore) {
        this.log.info("addRule " + ruleAction + " " + ruleset_1.Ruleset.rawRuleToCanonicalString(ruleData));
        this.assertRuleAction(ruleAction);
        this.userRulesets.user.rawRuleset.addRule(ruleAction, ruleData, this.userRulesets.user.ruleset);
        if (!noStore) {
            this.rulesetStorage.saveRawRulesetToFile(this.userRulesets.user.rawRuleset, "user");
        }
        notifyRulesChanged();
    };
    Policy.prototype.addRules = function (aRuleAction, aRuleDataList, aNoStore) {
        if (aNoStore === void 0) { aNoStore = false; }
        var e_1, _a;
        try {
            for (var aRuleDataList_1 = __values(aRuleDataList), aRuleDataList_1_1 = aRuleDataList_1.next(); !aRuleDataList_1_1.done; aRuleDataList_1_1 = aRuleDataList_1.next()) {
                var ruleData = aRuleDataList_1_1.value;
                this.addRule(aRuleAction, ruleData, true);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (aRuleDataList_1_1 && !aRuleDataList_1_1.done && (_a = aRuleDataList_1.return)) _a.call(aRuleDataList_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (false === aNoStore) {
            this.storeRules();
        }
    };
    Policy.prototype.storeRules = function () {
        this.rulesetStorage.saveRawRulesetToFile(this.userRulesets.user.rawRuleset, "user");
    };
    Policy.prototype.addTemporaryRule = function (ruleAction, ruleData) {
        this.log.info("addTemporaryRule " + ruleAction + " " + ruleset_1.Ruleset.rawRuleToCanonicalString(ruleData));
        this.assertRuleAction(ruleAction);
        this.userRulesets.temp.rawRuleset.addRule(ruleAction, ruleData, this.userRulesets.temp.ruleset);
        notifyRulesChanged();
    };
    Policy.prototype.removeRule = function (ruleAction, ruleData, noStore) {
        this.log.info("removeRule " + ruleAction + " " + ruleset_1.Ruleset.rawRuleToCanonicalString(ruleData));
        this.assertRuleAction(ruleAction);
        this.userRulesets.user.rawRuleset.removeRule(ruleAction, ruleData, this.userRulesets.user.ruleset);
        this.userRulesets.temp.rawRuleset.removeRule(ruleAction, ruleData, this.userRulesets.temp.ruleset);
        if (!noStore) {
            this.rulesetStorage.saveRawRulesetToFile(this.userRulesets.user.rawRuleset, "user");
        }
        notifyRulesChanged();
    };
    Policy.prototype.temporaryRulesExist = function () {
        return this.userRulesets.temp.rawRuleset.getAllowRuleCount() ||
            this.userRulesets.temp.rawRuleset.getDenyRuleCount();
    };
    Policy.prototype.revokeTemporaryRules = function () {
        var rawRuleset = ruleset_1.RawRuleset.create();
        this.userRulesets.temp = {
            rawRuleset: rawRuleset,
            ruleset: rawRuleset.toRuleset("temp"),
        };
        this.userRulesets.temp.ruleset.userRuleset = true;
        notifyRulesChanged();
    };
    Policy.prototype.checkRequestAgainstUserRules = function (origin, dest) {
        return this.checkRequest(origin, dest, this.userRulesets);
    };
    Policy.prototype.checkRequestAgainstSubscriptionRules = function (origin, dest) {
        var result = new request_result_1.RequestResult();
        var subscriptionRulesets = this.subscriptions.getRulesets();
        for (var listName in subscriptionRulesets) {
            var ruleset = subscriptionRulesets[listName];
            this.checkRequest(origin, dest, ruleset, result);
        }
        return result;
    };
    Policy.prototype.checkRequest = function (origin, dest, aRuleset, aResult) {
        var e_2, _a, e_3, _b;
        if (!(origin instanceof Ci.nsIURI)) {
            throw new Error("Origin must be an nsIURI.");
        }
        if (!(dest instanceof Ci.nsIURI)) {
            throw new Error("Destination must be an nsIURI.");
        }
        var result = aResult || new request_result_1.RequestResult();
        for (var name in aRuleset) {
            var ruleset = aRuleset[name].ruleset;
            var _c = __read(ruleset.check(origin, dest), 2), tempAllows = _c[0], tempDenies = _c[1];
            try {
                for (var tempAllows_1 = __values(tempAllows), tempAllows_1_1 = tempAllows_1.next(); !tempAllows_1_1.done; tempAllows_1_1 = tempAllows_1.next()) {
                    var tempAllow = tempAllows_1_1.value;
                    result.matchedAllowRules.push([ruleset, tempAllow]);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (tempAllows_1_1 && !tempAllows_1_1.done && (_a = tempAllows_1.return)) _a.call(tempAllows_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            try {
                for (var tempDenies_1 = __values(tempDenies), tempDenies_1_1 = tempDenies_1.next(); !tempDenies_1_1.done; tempDenies_1_1 = tempDenies_1.next()) {
                    var tempDeny = tempDenies_1_1.value;
                    result.matchedDenyRules.push([ruleset, tempDeny]);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (tempDenies_1_1 && !tempDenies_1_1.done && (_b = tempDenies_1.return)) _b.call(tempDenies_1);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
        return result;
    };
    Policy.prototype.getRuleData = function (aOrigin, aDest) {
        var ruleData = {};
        if (aOrigin !== undefined) {
            ruleData.o = { h: aOrigin };
        }
        if (aDest !== undefined) {
            ruleData.d = { h: aDest };
        }
        return ruleData;
    };
    Policy.prototype.addRuleBySpec = function (aSpec, noStore) {
        var ruleAction = aSpec.allow ? constants_1.C.RULE_ACTION_ALLOW : constants_1.C.RULE_ACTION_DENY;
        var ruleData = this.getRuleData(aSpec.origin, aSpec.dest);
        if (aSpec.temp) {
            this.addTemporaryRule(ruleAction, ruleData);
        }
        else {
            this.addRule(ruleAction, ruleData, noStore);
        }
    };
    Object.defineProperty(Policy.prototype, "subModules", {
        get: function () {
            return {
                rulesetStorage: this.rulesetStorage,
                subscriptions: this.subscriptions,
            };
        },
        enumerable: true,
        configurable: true
    });
    Policy.prototype.startupSelf = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.loadUserRules()];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Policy.prototype.assertRuleAction = function (ruleAction) {
        if (ruleAction !== constants_1.C.RULE_ACTION_ALLOW &&
            ruleAction !== constants_1.C.RULE_ACTION_DENY) {
            throw new Error("Invalid rule type: " + ruleAction);
        }
    };
    return Policy;
}(module_1.Module));
exports.Policy = Policy;