"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var module_1 = require("lib/classes/module");
var ruleset_1 = require("lib/ruleset");
var RulesetStorage = (function (_super) {
    __extends(RulesetStorage, _super);
    function RulesetStorage(log, storageArea) {
        var _this = _super.call(this, "RulesetStorage", log) || this;
        _this.storageArea = storageArea;
        return _this;
    }
    RulesetStorage.prototype.loadRawRulesetFromFile = function (policyName, subscriptionListName) {
        var _this = this;
        var key = this.getKey(policyName, subscriptionListName);
        var pResult = this.storageArea.get(key);
        var pRawRuleset = pResult.then(function (aResult) {
            if (!aResult.hasOwnProperty(key))
                return null;
            return ruleset_1.RawRuleset.create(aResult[key]);
        });
        pRawRuleset.catch(function (e) {
            _this.log.error("RulesetStorage.loadRawRulesetFromFile():", e);
        });
        return pRawRuleset;
    };
    RulesetStorage.prototype.saveRawRulesetToFile = function (policy, policyName, subscriptionListName) {
        var _this = this;
        var _a;
        var key = this.getKey(policyName, subscriptionListName);
        var p = this.storageArea.set((_a = {},
            _a[key] = policy,
            _a));
        p.catch(function (e) {
            _this.log.error("RulesetStorage.saveRawRulesetToFile():", e);
        });
    };
    RulesetStorage.prototype.getKey = function (policyName, subscriptionListName) {
        var key = "policies/";
        if (subscriptionListName) {
            key += "subscriptions/" + subscriptionListName + "/";
        }
        key += policyName;
        return key;
    };
    return RulesetStorage;
}(module_1.Module));
exports.RulesetStorage = RulesetStorage;