"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var module_1 = require("lib/classes/module");
var IDNService = null;
function splitString(aRulesString) {
    if (aRulesString === void 0) { aRulesString = ""; }
    var rules = new Set(aRulesString.split(" "));
    rules.delete("");
    return rules;
}
var V0RulesService = (function (_super) {
    __extends(V0RulesService, _super);
    function V0RulesService(log, uriService, xpcApi) {
        var _this = _super.call(this, "app.services.rules.v0", log) || this;
        _this.uriService = uriService;
        _this.xpcApi = xpcApi;
        _this.eTLDService = Services.eTLD;
        return _this;
    }
    V0RulesService.prototype.parse = function (aPrefStrings) {
        var e_1, _a, e_2, _b, e_3, _c;
        var dests = splitString(aPrefStrings.dests);
        var origins = splitString(aPrefStrings.origins);
        var originsToDests = splitString(aPrefStrings.originsToDests);
        var rules = [];
        try {
            for (var origins_1 = __values(origins), origins_1_1 = origins_1.next(); !origins_1_1.done; origins_1_1 = origins_1.next()) {
                var origin = origins_1_1.value;
                rules.push({
                    o: this.getEndpointSpecFromString(origin),
                });
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (origins_1_1 && !origins_1_1.done && (_a = origins_1.return)) _a.call(origins_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        try {
            for (var dests_1 = __values(dests), dests_1_1 = dests_1.next(); !dests_1_1.done; dests_1_1 = dests_1.next()) {
                var dest = dests_1_1.value;
                rules.push({
                    d: this.getEndpointSpecFromString(dest),
                });
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (dests_1_1 && !dests_1_1.done && (_b = dests_1.return)) _b.call(dests_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        try {
            for (var originsToDests_1 = __values(originsToDests), originsToDests_1_1 = originsToDests_1.next(); !originsToDests_1_1.done; originsToDests_1_1 = originsToDests_1.next()) {
                var originToDest = originsToDests_1_1.value;
                var parts = originToDest.split("|");
                if (parts.length === 2) {
                    var _d = __read(parts, 2), origin = _d[0], dest = _d[1];
                    if (origin !== "" && dest !== "") {
                        rules.push({
                            d: this.getEndpointSpecFromString(dest),
                            o: this.getEndpointSpecFromString(origin),
                        });
                        continue;
                    }
                }
                throw new V0RulesParseError("Invalid old rule: \"" + originToDest +
                    "\"");
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (originsToDests_1_1 && !originsToDests_1_1.done && (_c = originsToDests_1.return)) _c.call(originsToDests_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return rules;
    };
    V0RulesService.prototype.oldRulesExist = function () {
        if (!this.xpcApi)
            return false;
        return !(this.isV0RulePrefEmpty("allowedOrigins") &&
            this.isV0RulePrefEmpty("allowedDestinations") &&
            this.isV0RulePrefEmpty("allowedOriginsToDestinations"));
    };
    V0RulesService.prototype.getRPV0PrefString = function (aPrefName) {
        if (!this.xpcApi)
            return "";
        var result = this.getV0RulePref(aPrefName);
        return result || "";
    };
    V0RulesService.prototype.getRPV0PrefStrings = function () {
        if (!this.xpcApi) {
            return null;
        }
        return {
            dests: this.getRPV0PrefString("allowedDestinations"),
            origins: this.getRPV0PrefString("allowedOrigins"),
            originsToDests: this.getRPV0PrefString("allowedOriginsToDestinations"),
        };
    };
    V0RulesService.prototype.deleteOldRules = function () {
        if (!this.xpcApi)
            return;
        this.xpcApi.rpPrefBranch.reset("allowedOrigins");
        this.xpcApi.rpPrefBranch.reset("allowedDestinations");
        this.xpcApi.rpPrefBranch.reset("allowedOriginsToDestinations");
        this.xpcApi.prefsService.savePrefFile(null);
    };
    V0RulesService.prototype.shouldWildcardBeAddedToEndpoint = function (aEndpoint) {
        var _this = this;
        if (!IDNService) {
            IDNService = Cc["@mozilla.org/network/idn-service;1"].
                getService(Ci.nsIIDNService);
        }
        var host;
        var getBaseDomain;
        if (aEndpoint instanceof Ci.nsIURI) {
            var uri_1 = aEndpoint;
            host = this.uriService.getHostByUriObj(uri_1);
            getBaseDomain = function () { return _this.eTLDService.getBaseDomain(uri_1, 0); };
        }
        else {
            host = aEndpoint;
            getBaseDomain = function () { return _this.eTLDService.getBaseDomainFromHost(host, 0); };
        }
        try {
            var baseDomain = getBaseDomain();
            baseDomain = IDNService.convertToDisplayIDN(baseDomain, {});
            return host === baseDomain;
        }
        catch (e) {
            if (e.name === "NS_ERROR_INSUFFICIENT_DOMAIN_LEVELS") {
                return false;
            }
            else if (e.name === "NS_ERROR_HOST_IS_IP_ADDRESS") {
                return false;
            }
            else {
                throw e;
            }
        }
    };
    V0RulesService.prototype.getEndpointSpecFromString = function (aEndpointString) {
        var spec = {};
        if (this.uriService.isValidUri(aEndpointString)) {
            var uriObj = this.uriService.getUriObject(aEndpointString);
            spec.s = uriObj.scheme;
            var host = this.uriService.getHostByUriObj(uriObj);
            if (host !== null) {
                spec.h = host;
                if (this.shouldWildcardBeAddedToEndpoint(uriObj)) {
                    spec.h = "*." + spec.h;
                }
                if (uriObj.port !== -1) {
                    spec.port = uriObj.port;
                }
            }
        }
        else {
            spec.h = aEndpointString.split("/")[0];
            if (this.shouldWildcardBeAddedToEndpoint(spec.h)) {
                spec.h = "*." + spec.h;
            }
        }
        return spec;
    };
    V0RulesService.prototype.isV0RulePrefEmpty = function (pref) {
        if (!this.xpcApi)
            return true;
        return !this.xpcApi.rpPrefBranch.isSet(pref);
    };
    V0RulesService.prototype.getV0RulePref = function (pref) {
        if (!this.xpcApi)
            return null;
        if (!this.xpcApi.rpPrefBranch.isSet(pref))
            return null;
        return this.xpcApi.rpPrefBranch.get(pref);
    };
    return V0RulesService;
}(module_1.Module));
exports.V0RulesService = V0RulesService;
var V0RulesParseError = (function (_super) {
    __extends(V0RulesParseError, _super);
    function V0RulesParseError() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = "V0RulesParseError";
        return _this;
    }
    return V0RulesParseError;
}(Error));
exports.V0RulesParseError = V0RulesParseError;