"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var module_1 = require("lib/classes/module");
var CachedSettings = (function (_super) {
    __extends(CachedSettings, _super);
    function CachedSettings(log, _a, storageReadyPromise, rpPrefBranch, prefsService) {
        var cachedKeys = _a.cachedKeys, boolAliases = _a.boolAliases, defaultValues = _a.defaultValues;
        var _this = _super.call(this, "app.storage.cachedSettings", log) || this;
        _this.storageReadyPromise = storageReadyPromise;
        _this.rpPrefBranch = rpPrefBranch;
        _this.prefsService = prefsService;
        _this.alias = {};
        _this.cachedKeys = cachedKeys;
        _this.cachedKeysSet = new Set(cachedKeys);
        _this.defaultValues = defaultValues;
        boolAliases.forEach(function (_a) {
            var _b = __read(_a, 2), storageKey = _b[0], alias = _b[1];
            _this.alias["is" + alias] = function () { return _this.get(storageKey); };
            _this.alias["set" + alias] = function (value) {
                var _a;
                return _this.set((_a = {}, _a[storageKey] = value, _a));
            };
        });
        return _this;
    }
    Object.defineProperty(CachedSettings.prototype, "startupPreconditions", {
        get: function () {
            return [
                this.storageReadyPromise,
            ];
        },
        enumerable: true,
        configurable: true
    });
    CachedSettings.prototype.isKeyCached = function (aKey) {
        this.assertReady();
        return this.cachedKeysSet.has(aKey);
    };
    CachedSettings.prototype.get = function (aKeys) {
        var _this = this;
        this.assertReady();
        if (aKeys === "")
            return {};
        if (aKeys === null || aKeys === undefined) {
            return this.get(this.cachedKeys);
        }
        if (typeof aKeys === "string") {
            var key = aKeys;
            return this.getRaw(key);
        }
        if (Array.isArray(aKeys)) {
            var result_1 = {};
            aKeys.forEach(function (key) {
                result_1[key] = _this.getRaw(key);
            });
            return result_1;
        }
        throw new Error("Invalid key \"" + aKeys + "\"");
    };
    CachedSettings.prototype.set = function (aKeys) {
        var _this = this;
        this.assertReady();
        try {
            Object.keys(aKeys).forEach(function (key) {
                _this.rpPrefBranch.set(key, aKeys[key]);
            });
            this.prefsService.savePrefFile(null);
            return Promise.resolve();
        }
        catch (error) {
            console.error("[RequestPolicy] Error when saving to storage! Details:");
            console.dir(aKeys);
            console.dir(error);
            return Promise.reject(error);
        }
    };
    CachedSettings.prototype.getRaw = function (aKey) {
        if (!this.isKeyCached(aKey)) {
            throw new Error("Key \"" + aKey + "\" is not cached in Storage!");
        }
        var result = this.rpPrefBranch.get(aKey);
        return result === undefined ? this.defaultValues[aKey] : result;
    };
    return CachedSettings;
}(module_1.Module));
exports.CachedSettings = CachedSettings;