"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var boolAliases = [
    ["defaultPolicy.allow", "DefaultAllow"],
    ["defaultPolicy.allowSameDomain", "DefaultAllowSameDomain"],
    ["defaultPolicy.allowTopLevel", "DefaultAllowTopLevel"],
    ["startWithAllowAllEnabled", "BlockingDisabled"],
];
var keys = {
    "autoReload": {
        cached: true, defaultValue: true,
    },
    "browserSettings.disablePrefetching": {
        cached: true, defaultValue: true,
    },
    "confirmSiteInfo": {
        cached: true, defaultValue: true,
    },
    "contextMenu": {
        cached: true, defaultValue: true,
    },
    "defaultPolicy.allow": {
        cached: true, defaultValue: false,
    },
    "defaultPolicy.allowSameDomain": {
        cached: true, defaultValue: true,
    },
    "defaultPolicy.allowTopLevel": {
        cached: true, defaultValue: false,
    },
    "indicateBlacklistedObjects": {
        cached: true, defaultValue: false,
    },
    "indicateBlockedObjects": {
        cached: true, defaultValue: true,
    },
    "keyboardShortcuts.openMenu.combo": {
        cached: true, defaultValue: "default",
    },
    "keyboardShortcuts.openMenu.enabled": {
        cached: true, defaultValue: true,
    },
    "keyboardShortcuts.openRequestLog.combo": {
        cached: true, defaultValue: "default",
    },
    "keyboardShortcuts.openRequestLog.enabled": {
        cached: true, defaultValue: true,
    },
    "lastAppVersion": {
        cached: true, defaultValue: "0.0",
    },
    "lastVersion": {
        cached: true, defaultValue: "0.0",
    },
    "log": {
        cached: true, defaultValue: false,
    },
    "log.level": {
        cached: true, defaultValue: 0,
    },
    "menu.info.showNumRequests": {
        cached: true, defaultValue: true,
    },
    "menu.sorting": {
        cached: true, defaultValue: "numRequests",
    },
    "privateBrowsingPermanentWhitelisting": {
        cached: true, defaultValue: false,
    },
    "startWithAllowAllEnabled": {
        cached: true, defaultValue: false,
    },
    "welcomeWindowShown": {
        cached: true, defaultValue: false,
    },
};
var cachedKeys = [];
var defaultValues = {};
Object.keys(keys).forEach(function (key) {
    var spec = keys[key];
    if (spec.cached)
        cachedKeys.push(key);
    if (spec.hasOwnProperty("defaultValue")) {
        defaultValues[key] = spec.defaultValue;
    }
});
exports.SETTING_SPECS = {
    boolAliases: boolAliases,
    cachedKeys: cachedKeys,
    defaultValues: defaultValues,
};