"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _8_intl_1 = require("lib/polyfills/intl/8.intl");
function normalizeToBCP47(tag) {
    var bcpTag = tag.replace(/_/g, "-");
    var canonicalList = _8_intl_1.Intl.getCanonicalLocales(bcpTag);
    var result = canonicalList[0];
    return result.toLowerCase();
}
exports.normalizeToBCP47 = normalizeToBCP47;
function getBestAvailableLocale(availableLocales, locale) {
    var lcAvailable = availableLocales.map(function (l) { return l.toLowerCase(); });
    if (lcAvailable.indexOf(locale.toLowerCase()) !== -1) {
        return locale;
    }
    else {
        var pos = locale.lastIndexOf("-");
        if (pos === -1) {
            return undefined;
        }
        else {
            if (pos >= 2 && locale.charAt(pos - 2) === "-") {
                pos -= 2;
            }
            var candidate = locale.substring(0, pos);
            return getBestAvailableLocale(availableLocales, candidate);
        }
    }
}
exports.getBestAvailableLocale = getBestAvailableLocale;