"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var module_1 = require("lib/classes/module");
var L10nUtils = require("./l10n-utils");
var I18n = (function (_super) {
    __extends(I18n, _super);
    function I18n(log, localeData) {
        var _this = _super.call(this, "browser.i18n", log) || this;
        _this.localeData = localeData;
        return _this;
    }
    Object.defineProperty(I18n.prototype, "subModules", {
        get: function () {
            return {
                localeData: this.localeData,
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(I18n.prototype, "backgroundApi", {
        get: function () {
            return {
                getMessage: this.getMessage.bind(this),
                getUILanguage: this.getUILanguage.bind(this),
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(I18n.prototype, "contentApi", {
        get: function () {
            var api = this.backgroundApi;
            return {
                getMessage: api.getMessage,
                getUILanguage: api.getUILanguage,
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(I18n.prototype, "legacyApi", {
        get: function () {
            return {
                matchKeyPattern: L10nUtils.matchKeyPattern.bind(this),
                updateDocument: L10nUtils.updateDocument.bind(null, this),
                updateString: L10nUtils.updateString.bind(null, this),
            };
        },
        enumerable: true,
        configurable: true
    });
    I18n.prototype.getMessage = function (messageName, substitutions) {
        return this.localeData.
            localizeMessage(messageName, substitutions);
    };
    I18n.prototype.getUILanguage = function () {
        return this.localeData.getAppLocale();
    };
    return I18n;
}(module_1.Module));
exports.I18n = I18n;