"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var MSG_REGEXP = /__MSG_([A-Za-z0-9@_]+?)__/g;
function matchKeyPattern(aString) {
    if (!aString || (typeof aString !== "string"
        && !(aString instanceof String))) {
        return false;
    }
    return MSG_REGEXP.test(aString);
}
exports.matchKeyPattern = matchKeyPattern;
function updateString(i18n, aString) {
    return aString.replace(MSG_REGEXP, function (matched, message) { return i18n.getMessage(message, [], { defaultValue: matched }); });
}
exports.updateString = updateString;
function updateDocument(i18n, document) {
    var texts = document.evaluate("descendant::text()[contains(self::text(), \"__MSG_\")]", document, null, 7, null);
    for (var i = 0, maxi = texts.snapshotLength; i < maxi; i++) {
        var text = texts.snapshotItem(i);
        text.nodeValue = updateString(i18n, text.nodeValue);
    }
    var attributes = document.evaluate("descendant::*/attribute::*[contains(., \"__MSG_\")]", document, null, 7, null);
    for (var i = 0, maxi = attributes.snapshotLength; i < maxi; i++) {
        var attribute = attributes.snapshotItem(i);
        attribute.value = updateString(i18n, attribute.value);
    }
}
exports.updateDocument = updateDocument;