"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var module_1 = require("lib/classes/module");
var listener_factories_1 = require("lib/utils/listener-factories");
var Management = (function (_super) {
    __extends(Management, _super);
    function Management(log, addonManager) {
        var _this = _super.call(this, "browser.management", log) || this;
        _this.addonManager = addonManager;
        _this.addonListener = {
            onDisabled: _this.onAddonListenerEvent.bind(_this, "onDisabled"),
            onEnabled: _this.onAddonListenerEvent.bind(_this, "onEnabled"),
            onInstalled: _this.onAddonListenerEvent.bind(_this, "onInstalled"),
            onUninstalled: _this.onAddonListenerEvent.bind(_this, "onUninstalled"),
        };
        _this.MANAGEMENT_EVENTS = Object.freeze([
            "onEnabled",
            "onDisabled",
            "onInstalled",
            "onUninstalled",
        ]);
        _this.events = listener_factories_1.createListenersMap(_this.MANAGEMENT_EVENTS);
        return _this;
    }
    Object.defineProperty(Management.prototype, "backgroundApi", {
        get: function () {
            return {
                get: this.get.bind(this),
                getAll: this.getAll.bind(this),
                getSelf: this.getSelf.bind(this),
                onDisabled: this.events.interfaces.onDisabled,
                onEnabled: this.events.interfaces.onEnabled,
                onInstalled: this.events.interfaces.onInstalled,
                onUninstalled: this.events.interfaces.onUninstalled,
            };
        },
        enumerable: true,
        configurable: true
    });
    Management.prototype.get = function (aId) {
        var _this = this;
        var p = new Promise(function (resolve, reject) {
            _this.addonManager.getAddonByID(aId, function (addon) {
                try {
                    if (addon) {
                        resolve(_this.mapAddonInfoToWebextExtensionInfo(addon));
                    }
                    else {
                        reject();
                    }
                }
                catch (e) {
                    console.error("[RequestPolicy] browser.management.get()");
                    console.dir(e);
                    reject(e);
                }
            });
        });
        p.catch(function (e) {
            if (!e) {
                return;
            }
            _this.log.error("get()", e);
        });
        return p;
    };
    Management.prototype.getAll = function () {
        var _this = this;
        var pExtensionInfo = new Promise(function (resolve) { return (_this.addonManager.getAllAddons(resolve)); }).then(function (addons) { return (addons.map(_this.mapAddonInfoToWebextExtensionInfo)); });
        pExtensionInfo.catch(this.log.onError("getAll()"));
        return pExtensionInfo;
    };
    Management.prototype.getSelf = function () {
        return this.get("rpcontinued@non-amo.requestpolicy.org");
    };
    Management.prototype.startupSelf = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.addonManager.addAddonListener(this.addonListener);
                return [2];
            });
        });
    };
    Management.prototype.shutdownSelf = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.addonManager.removeAddonListener(this.addonListener);
                return [2];
            });
        });
    };
    Management.prototype.mapAddonInfoToWebextExtensionInfo = function (aAddon) {
        var id = aAddon.id, enabled = aAddon.isActive, name = aAddon.name, version = aAddon.version;
        return Object.freeze({
            enabled: enabled,
            id: id,
            name: name,
            version: version,
        });
    };
    Management.prototype.mapAddonListenerCallbackToManagementEventName = function (aCallbackName) {
        switch (aCallbackName) {
            case "onEnabled": return "onEnabled";
            case "onDisabled": return "onDisabled";
            case "onInstalled": return "onInstalled";
            case "onUninstalled": return "onUninstalled";
            default: throw new Error("Unhandled callback name \"" + aCallbackName + "\".");
        }
    };
    Management.prototype.onAddonListenerEvent = function (aALCallbackName, aAddon) {
        var webextEventName = this.
            mapAddonListenerCallbackToManagementEventName(aALCallbackName);
        var extensionInfo = this.mapAddonInfoToWebextExtensionInfo(aAddon);
        this.events.listenersMap[webextEventName].emit(extensionInfo);
    };
    return Management;
}(module_1.Module));
exports.Management = Management;