"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("data/constants");
var MiscInfos = (function () {
    function MiscInfos(appinfo, rpPrefBranch, vc) {
        this.appinfo = appinfo;
        this.rpPrefBranch = rpPrefBranch;
        this.vc = vc;
        this.lastAppVersion = this.rpPrefBranch.get("lastAppVersion");
        this.isFirefox = this.appinfo.ID === constants_1.C.FIREFOX_ID;
        this.isSeamonkey = this.appinfo.ID === constants_1.C.SEAMONKEY_ID;
        this.isGecko = this.appinfo.name !== "Pale Moon";
        this.isAustralis = this.isFirefox &&
            this.vc.compare(this.appinfo.platformVersion, "29") >= 0;
    }
    MiscInfos.prototype.isGeckoVersionAtLeast = function (aMinVersion) {
        return this.isGecko &&
            this.vc.compare(this.appinfo.platformVersion, aMinVersion) >= 0;
    };
    return MiscInfos;
}());
exports.MiscInfos = MiscInfos;