"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var maybe_promise_1 = require("lib/classes/maybe-promise");
var module_1 = require("lib/classes/module");
var listener_factories_1 = require("lib/utils/listener-factories");
var Runtime = (function (_super) {
    __extends(Runtime, _super);
    function Runtime(log, mozAppinfo) {
        var _this = _super.call(this, "browser.runtime", log) || this;
        _this.mozAppinfo = mozAppinfo;
        _this.events = listener_factories_1.createListenersMap(["onMessage"]);
        return _this;
    }
    Object.defineProperty(Runtime.prototype, "backgroundApi", {
        get: function () {
            return {
                getBrowserInfo: this.getBrowserInfo.bind(this),
                getURL: this.getURL.bind(this),
                onMessage: this.events.interfaces.onMessage,
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Runtime.prototype, "contentApi", {
        get: function () {
            return {
                connect: null,
                getManifest: null,
                getURL: null,
                onConnect: null,
                onMessage: null,
                sendMessage: this.sendMessageFromContent.bind(this),
            };
        },
        enumerable: true,
        configurable: true
    });
    Runtime.prototype.getBrowserInfo = function () {
        var _a = this.mozAppinfo, name = _a.name, vendor = _a.vendor, version = _a.version, buildID = _a.appBuildID;
        return Promise.resolve({ name: name, vendor: vendor, version: version, buildID: buildID });
    };
    Runtime.prototype.getURL = function (path) {
        var patternAbout = /^(?:\.\/|\/)?(?:content\/)?settings\/([^/]+)\.[hH][tT][mM][lL]$/mg;
        var patternChrome = /^(?:\.\/|\/)?(.+)$/mg;
        var legacyPath;
        if (patternAbout.test(path)) {
            legacyPath = path.replace(patternAbout, "about:requestpolicy?$1");
        }
        else {
            legacyPath = path.replace(patternChrome, "chrome://rpcontinued/$1");
        }
        return legacyPath;
    };
    Runtime.prototype.sendMessageFromContent = function (aMessage) {
        var responses = [];
        var callback = function (aResponse) {
            responses.push(aResponse);
        };
        return maybe_promise_1.MaybePromise.resolve(this.events.listenersMap.onMessage.emit(aMessage, null, callback)).then(function () {
            if (responses.length === 0)
                return;
            if (responses.length === 1)
                return responses[0];
            throw new Error("Got multiple responses!");
        }).toPromise();
    };
    return Runtime;
}(module_1.Module));
exports.Runtime = Runtime;