"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var module_1 = require("lib/classes/module");
var listener_factories_1 = require("lib/utils/listener-factories");
var Storage = (function (_super) {
    __extends(Storage, _super);
    function Storage(log, slsa, rpPrefBranch) {
        var _this = _super.call(this, "browser.storage", log) || this;
        _this.slsa = slsa;
        _this.rpPrefBranch = rpPrefBranch;
        _this.events = listener_factories_1.createListenersMap(["onChanged"]);
        _this.prefObserver = {
            observe: _this.observePrefChange.bind(_this),
        };
        return _this;
    }
    Object.defineProperty(Storage.prototype, "backgroundApi", {
        get: function () {
            return {
                local: {
                    get: this.getLocal.bind(this),
                    remove: this.removeLocal.bind(this),
                    set: this.setLocal.bind(this),
                },
                onChanged: this.events.interfaces.onChanged,
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Storage.prototype, "contentApi", {
        get: function () {
            return this.backgroundApi;
        },
        enumerable: true,
        configurable: true
    });
    Storage.prototype.startupSelf = function () {
        this.rpPrefBranch.addObserver("", this.prefObserver);
        return Promise.resolve();
    };
    Storage.prototype.shutdownSelf = function () {
        this.rpPrefBranch.removeObserver("", this.prefObserver);
        return Promise.resolve();
    };
    Storage.prototype.getLocal = function (aKeys) {
        return Promise.resolve(this.slsa.get(aKeys));
    };
    Storage.prototype.setLocal = function (aKeys) {
        try {
            return Promise.resolve(this.slsa.set(aKeys));
        }
        catch (e) {
            return Promise.reject(e);
        }
    };
    Storage.prototype.removeLocal = function (aKeys) {
        try {
            var result = this.slsa.remove(aKeys);
            if (result && "errors" in result) {
                return Promise.reject(result.errors);
            }
            return Promise.resolve();
        }
        catch (e) {
            return Promise.reject(e);
        }
    };
    Storage.prototype.observePrefChange = function (aSubject, aTopic, aData) {
        var prefName = aData;
        var newValue = this.rpPrefBranch.get(prefName);
        var changes = newValue === undefined ? {} : { newValue: newValue };
        this.events.listenersMap.onChanged.emit({ changes: changes });
    };
    return Storage;
}(module_1.Module));
exports.Storage = Storage;