"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("data/constants");
var object_interface_1 = require("lib/classes/object-interface");
var SyncLocalStorageArea = (function (_super) {
    __extends(SyncLocalStorageArea, _super);
    function SyncLocalStorageArea(prefsService, rpPrefBranch, jsonStorage) {
        var _this = _super.call(this) || this;
        _this.prefsService = prefsService;
        _this.rpPrefBranch = rpPrefBranch;
        _this.jsonStorage = jsonStorage;
        return _this;
    }
    SyncLocalStorageArea.prototype.getAll = function () {
        return Object.assign({}, this.rpPrefBranch.getAll(), this.jsonStorage.getAll());
    };
    SyncLocalStorageArea.prototype.getNothing = function () {
        return {};
    };
    SyncLocalStorageArea.prototype.getByKeys = function (aKeys) {
        var _this = this;
        var results = {};
        aKeys.forEach(function (key) {
            var isJson = _this.jsonStorage.isJsonStorageKey(key);
            var result = isJson ?
                _this.jsonStorage.get(key) :
                _this.rpPrefBranch.get(key);
            var undefinedValue = isJson ? constants_1.C.UNDEFINED : undefined;
            if (result !== undefinedValue) {
                results[key] = result;
            }
        });
        return results;
    };
    SyncLocalStorageArea.prototype.setByKey = function (aKey, aValue) {
        if (this.jsonStorage.isJsonStorageKey(aKey)) {
            this.jsonStorage.set(aKey, aValue);
        }
        else {
            this.rpPrefBranch.set(aKey, aValue);
            this.prefsService.savePrefFile(null);
        }
    };
    SyncLocalStorageArea.prototype.removeByKeys = function (aKeys) {
        var _this = this;
        var errors = {};
        aKeys.forEach(function (key) {
            try {
                _this.jsonStorage.isJsonStorageKey(key) ?
                    _this.jsonStorage.remove(key) : _this.rpPrefBranch.reset(key);
            }
            catch (e) {
                errors[key] = e;
            }
        });
        return { errors: errors };
    };
    return SyncLocalStorageArea;
}(object_interface_1.AbstractObjectInterface));
exports.SyncLocalStorageArea = SyncLocalStorageArea;