"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var app_background_1 = require("app/app.background");
var keyboard_shortcut_1 = require("lib/classes/keyboard-shortcut");
var ui_startup_1 = require("models/ui-startup");
var window_manager_1 = require("main/window-manager");
var keyboardShortcuts = [];
exports.KeyboardShortcutController = {
    startupPreconditions: [
        app_background_1.rp.storage.cachedSettings.pReady,
        ui_startup_1.pWindowsAvailable,
        window_manager_1.rpWindowManager.pStartup,
    ],
    startup: function () {
        keyboardShortcuts.push(new keyboard_shortcut_1.KeyboardShortcut("openMenu", "alt shift r", function (window) {
            window.rpcontinued.overlay.toggleMenu();
        }, "keyboardShortcuts.openMenu.enabled", "keyboardShortcuts.openMenu.combo"));
        keyboardShortcuts.push(new keyboard_shortcut_1.KeyboardShortcut("openRequestLog", "none", function (window) {
            window.rpcontinued.overlay.toggleRequestLog();
        }, "keyboardShortcuts.openRequestLog.enabled", "keyboardShortcuts.openRequestLog.combo"));
    },
    shutdown: function () {
        keyboardShortcuts.forEach(function (ks) {
            ks.destroy();
        });
        keyboardShortcuts.length = 0;
    },
};