"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var XULUtils = require("lib/utils/xul-utils");
var overlay_js_1 = require("ui/overlay.js");
var menu_js_1 = require("ui/menu.js");
var classicmenu_js_1 = require("ui/classicmenu.js");
exports.OverlayController = (function () {
    var self = {};
    self.loadIntoWindow = function (window) {
        window.rpcontinued = {};
        overlay_js_1.loadOverlayIntoWindow(window);
        menu_js_1.loadMenuIntoWindow(window);
        classicmenu_js_1.loadClassicmenuIntoWindow(window);
        XULUtils.addTreeElementsToWindow(window, "mainTree");
        window.rpcontinued.overlay.init();
    };
    self.unloadFromWindow = function (window) {
        XULUtils.removeTreeElementsFromWindow(window, "mainTree");
        delete window.rpcontinued;
    };
    return self;
})();