"use strict";
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StyleSheetsController = (function () {
    var self = {};
    var STYLE_SHEETS = Object.freeze([
        "chrome://rpcontinued/skin/requestpolicy.css",
        LegacyApi.miscInfos.isSeamonkey ?
            "chrome://rpcontinued/skin/toolbarbutton-seamonkey.css" :
            "chrome://rpcontinued/skin/toolbarbutton.css",
    ]);
    function loadStyleSheets() {
        var e_1, _a;
        var styleSheetService = Cc["@mozilla.org/content/style-sheet-service;1"].
            getService(Ci.nsIStyleSheetService);
        try {
            for (var STYLE_SHEETS_1 = __values(STYLE_SHEETS), STYLE_SHEETS_1_1 = STYLE_SHEETS_1.next(); !STYLE_SHEETS_1_1.done; STYLE_SHEETS_1_1 = STYLE_SHEETS_1.next()) {
                var styleSheet = STYLE_SHEETS_1_1.value;
                var styleSheetURI = Services.io.newURI(styleSheet, null, null);
                styleSheetService.loadAndRegisterSheet(styleSheetURI, styleSheetService.AUTHOR_SHEET);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (STYLE_SHEETS_1_1 && !STYLE_SHEETS_1_1.done && (_a = STYLE_SHEETS_1.return)) _a.call(STYLE_SHEETS_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    function unloadStyleSheets() {
        var e_2, _a;
        var styleSheetService = Cc["@mozilla.org/content/style-sheet-service;1"].
            getService(Ci.nsIStyleSheetService);
        try {
            for (var STYLE_SHEETS_2 = __values(STYLE_SHEETS), STYLE_SHEETS_2_1 = STYLE_SHEETS_2.next(); !STYLE_SHEETS_2_1.done; STYLE_SHEETS_2_1 = STYLE_SHEETS_2.next()) {
                var styleSheet = STYLE_SHEETS_2_1.value;
                var styleSheetURI = Services.io.newURI(styleSheet, null, null);
                if (styleSheetService.sheetRegistered(styleSheetURI, styleSheetService.AUTHOR_SHEET)) {
                    styleSheetService.unregisterSheet(styleSheetURI, styleSheetService.AUTHOR_SHEET);
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (STYLE_SHEETS_2_1 && !STYLE_SHEETS_2_1.done && (_a = STYLE_SHEETS_2.return)) _a.call(STYLE_SHEETS_2);
            }
            finally { if (e_2) throw e_2.error; }
        }
    }
    self.startup = function () {
        loadStyleSheets();
    };
    self.shutdown = function () {
        unloadStyleSheets();
    };
    return self;
})();