"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("data/constants");
var environment_1 = require("lib/environment");
var managers_1 = require("framescripts/managers");
(function () {
    var content = cfmm.content, sendSyncMessage = cfmm.sendSyncMessage;
    function reloadDocument() {
        content.document.location.reload(false);
    }
    managers_1.mlManager.addListener("reload", reloadDocument);
    function setLocation(aUri, aReplace) {
        if (aReplace) {
            content.document.location.replace(aUri);
        }
        else {
            content.document.location.assign(aUri);
        }
    }
    managers_1.mlManager.addListener("setLocation", function (message) {
        var replace = "replaceUri" in message.data &&
            message.data.replaceUri === content.document.location.href;
        setLocation(message.data.uri, replace);
    });
    function mouseClicked(event) {
        if (!event.mozInputSource) {
            return;
        }
        if (event.button !== 0) {
            return;
        }
        if (event.target.nodeName.toLowerCase() === "a" && event.target.href) {
            managers_1.overlayComm.run(function () {
                sendSyncMessage(constants_1.C.MM_PREFIX + "notifyLinkClicked", {
                    origin: event.target.ownerDocument.URL,
                    dest: event.target.href,
                });
            });
            return;
        }
        if (event.target.nodeName.toLowerCase() === "input" &&
            event.target.type.toLowerCase() === "submit" &&
            event.target.form && event.target.form.action) {
            managers_1.overlayComm.run(function () {
                sendSyncMessage(constants_1.C.MM_PREFIX + "registerFormSubmitted", {
                    origin: event.target.ownerDocument.URL,
                    dest: event.target.form.action,
                });
            });
            return;
        }
    }
    environment_1.MainEnvironment.addStartupFunction(environment_1.Level.INTERFACE, function () {
        environment_1.MainEnvironment.elManager.addListener(cfmm, "click", mouseClicked, true);
    });
})();