"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var map_of_sets_1 = require("lib/classes/map-of-sets");
function maybeForEach(aObj, aPropName, aCallback) {
    if (aObj.hasOwnProperty(aPropName)) {
        aObj[aPropName].forEach(aCallback);
    }
}
var ExtensionCompatibilityRules = (function () {
    function ExtensionCompatibilityRules(aSpec) {
        var _this = this;
        this.spec = aSpec;
        this.update();
        this.listener = function (info) {
            _this.update();
        };
        browser.management.onEnabled.addListener(this.listener);
        browser.management.onDisabled.addListener(this.listener);
    }
    Object.defineProperty(ExtensionCompatibilityRules.prototype, "whenReady", {
        get: function () {
            return this.pWhenReady;
        },
        enumerable: true,
        configurable: true
    });
    ExtensionCompatibilityRules.prototype[Symbol.iterator] = function () {
        var e_1, _a, _b, _c, _d, rule, addonIds, addonNames, _e, origin, dest, e_1_1;
        var _this = this;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    _f.trys.push([0, 5, 6, 7]);
                    _b = __values(this.extRulesToIds.mapEntries()), _c = _b.next();
                    _f.label = 1;
                case 1:
                    if (!!_c.done) return [3, 4];
                    _d = __read(_c.value, 2), rule = _d[0], addonIds = _d[1];
                    addonNames = Array.from(addonIds).
                        map(function (id) { return _this.addonIdsToNames.get(id); }).
                        join(", ");
                    _e = __read(rule, 2), origin = _e[0], dest = _e[1];
                    return [4, { origin: origin, dest: dest, info: addonNames }];
                case 2:
                    _f.sent();
                    _f.label = 3;
                case 3:
                    _c = _b.next();
                    return [3, 1];
                case 4: return [3, 7];
                case 5:
                    e_1_1 = _f.sent();
                    e_1 = { error: e_1_1 };
                    return [3, 7];
                case 6:
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7];
                case 7: return [2];
            }
        });
    };
    ExtensionCompatibilityRules.prototype.checkBaseUriWhitelist = function (aBaseUri) {
        var _this = this;
        var addonIds = this.whitelistedBaseUrisToIds.get(aBaseUri);
        if (addonIds === undefined) {
            return { isWhitelisted: false };
        }
        var addonNames = Array.from(addonIds).map(function (addonId) { return _this.addonIdsToNames.get(addonId); }).
            join(", ");
        return { isWhitelisted: true, addonNames: addonNames };
    };
    ExtensionCompatibilityRules.prototype.getTopLevelDocTranslation = function (uri) {
        var info = this.topLevelDocTranslationRules.get(uri);
        if (info === undefined) {
            return null;
        }
        return info.translatedUri;
    };
    ExtensionCompatibilityRules.prototype.update = function () {
        var _this = this;
        this.pWhenReady = browser.management.getAll().
            then(function (extensionInfos) {
            Object.assign(_this, _this.extensionInfosToCompatibilityRules(extensionInfos));
            return;
        });
        this.pWhenReady.
            catch(function (e) {
            console.error("[RequestPolicy] Could not update extension compatibility. Details:");
            console.dir(e);
        });
    };
    ExtensionCompatibilityRules.prototype.extensionInfosToCompatibilityRules = function (aExtensionInfos) {
        var e_2, _a;
        var addonIdsToNames = new Map();
        var extRulesToIds = new map_of_sets_1.MapOfSets();
        var whitelistedBaseUrisToIds = new map_of_sets_1.MapOfSets();
        var topLevelDocTranslationRules = new Map();
        var enabledAddons = aExtensionInfos.filter(function (addon) { return addon.enabled; });
        var idsToExtInfos = new Map();
        try {
            for (var enabledAddons_1 = __values(enabledAddons), enabledAddons_1_1 = enabledAddons_1.next(); !enabledAddons_1_1.done; enabledAddons_1_1 = enabledAddons_1.next()) {
                var addon = enabledAddons_1_1.value;
                idsToExtInfos.set(addon.id, addon);
                addonIdsToNames.set(addon.id, addon.name);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (enabledAddons_1_1 && !enabledAddons_1_1.done && (_a = enabledAddons_1.return)) _a.call(enabledAddons_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        this.spec.forEach(function (spec) {
            var enabledAddonIds = spec.ids.
                filter(function (id) { return idsToExtInfos.has(id); });
            if (enabledAddonIds.length === 0) {
                return;
            }
            maybeForEach(spec, "rules", function (rule) {
                var e_3, _a;
                try {
                    for (var enabledAddonIds_1 = __values(enabledAddonIds), enabledAddonIds_1_1 = enabledAddonIds_1.next(); !enabledAddonIds_1_1.done; enabledAddonIds_1_1 = enabledAddonIds_1.next()) {
                        var id = enabledAddonIds_1_1.value;
                        extRulesToIds.addToSet(rule, id);
                    }
                }
                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                finally {
                    try {
                        if (enabledAddonIds_1_1 && !enabledAddonIds_1_1.done && (_a = enabledAddonIds_1.return)) _a.call(enabledAddonIds_1);
                    }
                    finally { if (e_3) throw e_3.error; }
                }
            });
            maybeForEach(spec, "whitelistedBaseURIs", function (baseUri) {
                var e_4, _a;
                try {
                    for (var enabledAddonIds_2 = __values(enabledAddonIds), enabledAddonIds_2_1 = enabledAddonIds_2.next(); !enabledAddonIds_2_1.done; enabledAddonIds_2_1 = enabledAddonIds_2.next()) {
                        var id = enabledAddonIds_2_1.value;
                        whitelistedBaseUrisToIds.addToSet(baseUri, id);
                    }
                }
                catch (e_4_1) { e_4 = { error: e_4_1 }; }
                finally {
                    try {
                        if (enabledAddonIds_2_1 && !enabledAddonIds_2_1.done && (_a = enabledAddonIds_2.return)) _a.call(enabledAddonIds_2);
                    }
                    finally { if (e_4) throw e_4.error; }
                }
            });
            var processRawTopLevelDocTranslationRule = function (rules) {
                rules.forEach(function (rule) {
                    var _a = __read(rule, 2), uriToBeTranslated = _a[0], translatedUri = _a[1];
                    if (topLevelDocTranslationRules.has(uriToBeTranslated)) {
                        console.error("[RequestPolicy] Multiple definitions of traslation rule " +
                            ("\"" + uriToBeTranslated + "\"."));
                    }
                    topLevelDocTranslationRules.set(uriToBeTranslated, {
                        extensionIds: enabledAddonIds,
                        translatedUri: translatedUri,
                    });
                });
            };
            maybeForEach(spec, "topLevelDocTranslationRules", processRawTopLevelDocTranslationRule);
        });
        return {
            addonIdsToNames: addonIdsToNames,
            extRulesToIds: extRulesToIds,
            topLevelDocTranslationRules: topLevelDocTranslationRules,
            whitelistedBaseUrisToIds: whitelistedBaseUrisToIds,
        };
    };
    return ExtensionCompatibilityRules;
}());
exports.ExtensionCompatibilityRules = ExtensionCompatibilityRules;