"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Controllers = (function () {
    function Controllers(aControllers) {
        this.controllers = aControllers;
    }
    Controllers.prototype.shutdown = function () {
        this.controllers.reverse().forEach(function (controller) {
            if (typeof controller.shutdown === "function") {
                controller.shutdown();
            }
        });
    };
    Controllers.prototype.startup = function () {
        this.controllers.forEach(function (controller) {
            if (typeof controller.startup === "function") {
                if (typeof controller.startupPreconditions !== "undefined") {
                    Promise.all(controller.startupPreconditions).
                        then(controller.startup).
                        catch(function (e) {
                        console.error("[RequestPolicy] controller startup");
                        console.dir(e);
                    });
                }
                else {
                    controller.startup();
                }
            }
        });
    };
    return Controllers;
}());
exports.Controllers = Controllers;