"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var set_1 = require("lib/classes/set");
var Listeners = (function (_super) {
    __extends(Listeners, _super);
    function Listeners() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.interface = {
            addListener: _this.add.bind(_this),
            hasListener: _this.has.bind(_this),
            removeListener: _this.delete.bind(_this),
        };
        return _this;
    }
    Listeners.prototype.emit = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var e_1, _a;
        var returnValues = [];
        var withPromises = false;
        try {
            for (var _b = __values(this.values()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var listener = _c.value;
                var rv = listener.apply(void 0, __spread(args));
                if (rv && typeof rv.then === "function") {
                    withPromises = true;
                }
                if (rv !== undefined) {
                    returnValues.push(rv);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (!withPromises)
            return returnValues;
        return Promise.all(returnValues.map(function (rv) { return typeof rv.then === "function" ? rv : Promise.resolve(rv); }));
    };
    return Listeners;
}(set_1.OverridableSet));
exports.Listeners = Listeners;