"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var MapOfCustomSets = (function () {
    function MapOfCustomSets(aSetFactory) {
        this.map = new Map();
        this.getNewSet = aSetFactory;
    }
    MapOfCustomSets.prototype.has = function (aMapKey) {
        return this.map.has(aMapKey);
    };
    MapOfCustomSets.prototype.get = function (aMapKey) {
        return this.map.get(aMapKey);
    };
    MapOfCustomSets.prototype.keys = function () {
        return this.map.keys();
    };
    MapOfCustomSets.prototype.hasInSet = function (aMapKey, aValue) {
        var set = this.map.get(aMapKey);
        if (!set)
            return false;
        return set.has(aValue);
    };
    MapOfCustomSets.prototype.addToSet = function (aMapKey, aValue) {
        var set;
        if (!this.map.has(aMapKey)) {
            set = this.getNewSet();
            this.map.set(aMapKey, set);
        }
        else {
            set = this.map.get(aMapKey);
        }
        set.add(aValue);
    };
    MapOfCustomSets.prototype.deleteFromSet = function (aMapKey, aValue) {
        var set = this.map.get(aMapKey);
        if (set === undefined) {
            return;
        }
        set.delete(aValue);
        if (set.size === 0) {
            this.map.delete(aMapKey);
        }
    };
    MapOfCustomSets.prototype.mapEntries = function () {
        return this.map.entries();
    };
    MapOfCustomSets.prototype.forEachSet = function (aCallback) {
        this.map.forEach(aCallback);
    };
    MapOfCustomSets.prototype.forEach = function (aCallback) {
        this.map.forEach(function (set, mapKey) {
            set.forEach(function (setValue) {
                aCallback(setValue, mapKey);
            });
        });
    };
    return MapOfCustomSets;
}());
exports.MapOfCustomSets = MapOfCustomSets;