"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var js_utils_1 = require("lib/utils/js-utils");
var Module = (function () {
    function Module(moduleName, parentLog) {
        var _this = this;
        this.moduleName = moduleName;
        this.dReady = js_utils_1.defer();
        this.ready = false;
        this.dSelfBootstrap = {
            shutdown: js_utils_1.defer(),
            startup: js_utils_1.defer(),
        };
        this.dChildBootstrap = {
            shutdown: js_utils_1.defer(),
            startup: js_utils_1.defer(),
        };
        this.pBootstrap = {
            shutdown: Promise.all([
                this.dChildBootstrap.shutdown.promise,
                this.dSelfBootstrap.shutdown.promise,
            ]).then(function () { return undefined; }),
            startup: Promise.all([
                this.dChildBootstrap.startup.promise,
                this.dSelfBootstrap.startup.promise,
            ]).then(function () { return undefined; }),
        };
        this.log = parentLog.extend({ name: moduleName });
        this.debugLog = this.log.extend({ enabled: false });
        setTimeout(function () {
            if (_this.ready)
                return;
            _this.log.error("not ready even after 5 seconds!");
        }, 5000);
    }
    Object.defineProperty(Module.prototype, "subModules", {
        get: function () {
            return undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Module.prototype, "whenReady", {
        get: function () { return this.dReady.promise; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Module.prototype, "startupPreconditions", {
        get: function () {
            return [];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Module.prototype, "shutdownPreconditions", {
        get: function () {
            return [];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Module.prototype, "pStartup", {
        get: function () { return this.pBootstrap.startup; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Module.prototype, "pShutdown", {
        get: function () { return this.pBootstrap.shutdown; },
        enumerable: true,
        configurable: true
    });
    Module.prototype.startup = function () {
        return __awaiter(this, void 0, Promise, function () {
            var p;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.debugLog.log("starting up...");
                        p = this.startup_();
                        p.catch(this.log.onError("error on startup"));
                        return [4, p];
                    case 1:
                        _a.sent();
                        this.ready = true;
                        this.dReady.resolve(undefined);
                        this.debugLog.log("startup done");
                        return [2];
                }
            });
        });
    };
    Module.prototype.shutdown = function () {
        return __awaiter(this, void 0, Promise, function () {
            var p;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.debugLog.log("shutting down...");
                        p = this.shutdown_();
                        p.catch(this.log.onError("error on shutdown"));
                        return [4, p];
                    case 1:
                        _a.sent();
                        this.debugLog.log("done shutting down");
                        return [2];
                }
            });
        });
    };
    Module.prototype.startupSelf = function () {
        return Promise.resolve();
    };
    Module.prototype.shutdownSelf = function () {
        return Promise.resolve();
    };
    Module.prototype.assertReady = function () {
        if (!this.ready) {
            var msg = "Module \"" + this.moduleName + "\" is not ready yet!";
            this.log.error(msg);
            console.trace();
            throw new Error(msg);
        }
    };
    Module.prototype.startup_ = function () {
        return __awaiter(this, void 0, Promise, function () {
            var n;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.startupPreconditions.length !== 0)) return [3, 2];
                        n = this.startupPreconditions.length;
                        this.debugLog.log("awaiting " + n + " precondition" + (n > 1 ? "s" : "") + "...");
                        return [4, Promise.all(this.startupPreconditions)];
                    case 1:
                        _a.sent();
                        this.debugLog.log("done awaiting preconditions");
                        _a.label = 2;
                    case 2:
                        this.debugLog.log("starting up self and submodules...");
                        return [4, Promise.all([
                                this.runSubmoduleFns("startup"),
                                this.runSelfFn("startup"),
                            ])];
                    case 3:
                        _a.sent();
                        this.debugLog.log("done starting up self and submodules");
                        return [2];
                }
            });
        });
    };
    Module.prototype.shutdown_ = function () {
        return __awaiter(this, void 0, Promise, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, Promise.all(this.shutdownPreconditions)];
                    case 1:
                        _a.sent();
                        return [4, this.runSelfFn("shutdown")];
                    case 2:
                        _a.sent();
                        return [4, this.runSubmoduleFns("shutdown")];
                    case 3:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Module.prototype.getSubmodules = function () {
        var _this = this;
        if (!this.subModules)
            return [];
        return Object.keys(this.subModules).
            map(function (key) { return _this.subModules[key]; }).
            filter(function (m, index) {
            if (!m) {
                _this.log.error("submodule #" + (index + 1) + " is " + JSON.stringify(m));
                console.trace();
            }
            return !!m;
        });
    };
    Module.prototype.runSubmoduleFns = function (fnName) {
        var p = Promise.all(this.getSubmodules().
            filter(function (m) { return fnName in m; }).
            map(function (m) { return m[fnName](); })).then(function () { return undefined; });
        p.catch(this.log.onError("submodule " + fnName));
        this.dChildBootstrap[fnName].resolve(p);
        return p;
    };
    Module.prototype.runSelfFn = function (fnName) {
        var selfFnName = fnName + "Self";
        var p = this[selfFnName] ? this[selfFnName]() : Promise.resolve();
        p.catch(this.log.onError("self-" + fnName));
        this.dSelfBootstrap[fnName].resolve(p);
        return p;
    };
    return Module;
}());
exports.Module = Module;