"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var listener_factories_1 = require("lib/utils/listener-factories");
var AbstractObjectInterface = (function () {
    function AbstractObjectInterface() {
        this.eventListenersMap = listener_factories_1.createListenersMap([
            "onChanged",
        ]).listenersMap;
        this.onChanged = this.eventListenersMap.onChanged.interface;
    }
    AbstractObjectInterface.prototype.get = function (aKeys) {
        var e_1, _a;
        var keys;
        var isObjectWithDefaults = false;
        if (typeof aKeys === "string") {
            keys = [aKeys];
        }
        else if (typeof aKeys === "object" && aKeys !== null) {
            if (Array.isArray(aKeys)) {
                keys = aKeys;
            }
            else {
                isObjectWithDefaults = true;
                keys = Object.keys(aKeys);
            }
            if (keys.length === 0) {
                return this.getNothing();
            }
        }
        else {
            return this.getAll();
        }
        var results = this.getByKeys(keys);
        if (isObjectWithDefaults) {
            var defaults = aKeys;
            try {
                for (var keys_1 = __values(keys), keys_1_1 = keys_1.next(); !keys_1_1.done; keys_1_1 = keys_1.next()) {
                    var key = keys_1_1.value;
                    if (!(results.hasOwnProperty(key))) {
                        results[key] = defaults[key];
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (keys_1_1 && !keys_1_1.done && (_a = keys_1.return)) _a.call(keys_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        return results;
    };
    AbstractObjectInterface.prototype.set = function (aKeys) {
        var _this = this;
        if (typeof aKeys !== "object") {
            throw new Error("aKeys must be an object!");
        }
        Object.keys(aKeys).forEach(function (key) {
            _this.setByKey(key, aKeys[key]);
        });
        this.eventListenersMap.onChanged.emit();
    };
    AbstractObjectInterface.prototype.remove = function (aKeys) {
        if (typeof aKeys === "string") {
            aKeys = [aKeys];
        }
        var rv = this.removeByKeys(aKeys);
        this.eventListenersMap.onChanged.emit();
        if (rv && Object.keys(rv.errors).length === 0)
            return;
        return rv;
    };
    return AbstractObjectInterface;
}());
exports.AbstractObjectInterface = AbstractObjectInterface;
var ObjectInterface = (function (_super) {
    __extends(ObjectInterface, _super);
    function ObjectInterface(aObject) {
        var _this = _super.call(this) || this;
        _this.obj = aObject;
        return _this;
    }
    ObjectInterface.prototype.getAll = function () {
        return Object.assign({}, this.obj);
    };
    ObjectInterface.prototype.getNothing = function () {
        return {};
    };
    ObjectInterface.prototype.getByKeys = function (aKeys) {
        var _this = this;
        var rv = {};
        aKeys.forEach(function (key) {
            if (key in _this.obj)
                rv[key] = _this.obj[key];
        });
        return rv;
    };
    ObjectInterface.prototype.setByKey = function (key, value) {
        this.obj[key] = value;
    };
    ObjectInterface.prototype.removeByKeys = function (keys) {
        var _this = this;
        keys.forEach(function (key) {
            if (key in _this.obj)
                delete _this.obj[key];
        });
    };
    return ObjectInterface;
}(AbstractObjectInterface));
exports.ObjectInterface = ObjectInterface;