"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var log_1 = require("lib/classes/log");
var RPLog = (function (_super) {
    __extends(RPLog, _super);
    function RPLog(asyncSettingsPromise) {
        var _this = _super.call(this, {
            enabled: true,
            level: log_1.LogLevel.ALL,
            prefix: "",
        }) || this;
        var pEnabled = asyncSettingsPromise.then(function (asyncSettings) {
            _this.asyncSettings = asyncSettings;
            return asyncSettings.whenReady;
        }).then(function () {
            return _this.asyncSettings.get([
                "log",
                "log.level",
            ]);
        }).then(function (result) {
            _this.setLevel(result["log.level"]);
            var enable = result.log;
            _this.asyncSettings.onChanged.addListener(_this.onStorageChange.bind(_this));
            return enable;
        });
        pEnabled.catch(function (e) {
            _this.error("Error initializing the logger:", e);
        });
        _this.setEnabled(pEnabled);
        return _this;
    }
    RPLog.prototype.onStorageChange = function (aChanges, aAreaName) {
        if (aChanges.hasOwnProperty("log")) {
            this.setEnabled(aChanges.log.newValue);
        }
        if (aChanges.hasOwnProperty("log.level")) {
            this.setLevel(aChanges["log.level"].newValue);
        }
    };
    return RPLog;
}(log_1.Log));
exports.RPLog = RPLog;