"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var XPCOMObserver = (function () {
    function XPCOMObserver(aTopics, aCallback) {
        this.isRegistered = false;
        this.topics = [];
        this.topics = Array.isArray(aTopics) ? aTopics : [aTopics];
        this.observer = { observe: aCallback };
        this.register();
    }
    XPCOMObserver.prototype.register = function () {
        var _this = this;
        if (this.isRegistered)
            return;
        this.topics.forEach(function (topic) {
            Services.obs.addObserver(_this.observer, topic, false);
        });
        this.isRegistered = true;
    };
    XPCOMObserver.prototype.unregister = function () {
        var _this = this;
        if (!this.isRegistered)
            return;
        this.topics.forEach(function (topic) {
            Services.obs.removeObserver(_this.observer, topic);
        });
        this.isRegistered = false;
    };
    return XPCOMObserver;
}());
exports.XPCOMObserver = XPCOMObserver;