"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var log_1 = require("app/log");
var try_catch_utils_1 = require("lib/utils/try-catch-utils");
var HttpChannelWrapper = (function () {
    function HttpChannelWrapper(aHttpChannel) {
        this._httpChannel = aHttpChannel;
    }
    Object.defineProperty(HttpChannelWrapper.prototype, "uri", {
        get: function () {
            if (!this.hasOwnProperty("_uri")) {
                this._uri = Services.io.newURI(this._httpChannel.name, null, null);
            }
            return this._uri;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HttpChannelWrapper.prototype, "loadContext", {
        get: function () {
            if (!this.hasOwnProperty("_loadContext")) {
                var result = try_catch_utils_1.getLoadContextFromHttpChannel(this._httpChannel);
                this._loadContext = result.value;
                if (this._loadContext === null) {
                    log_1.log.warn("" + "The HTTPChannel's " +
                        "Load Context couldn't be found! " + result.error);
                }
            }
            return this._loadContext;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HttpChannelWrapper.prototype, "browser", {
        get: function () {
            if (!this.hasOwnProperty("_browser")) {
                var loadContext = this.loadContext;
                if (loadContext === null) {
                    this._browser = null;
                }
                else {
                    var result = try_catch_utils_1.getBrowserFromLoadContext(loadContext);
                    this._browser = result.value;
                    if (this._browser === null) {
                        log_1.log.warn("" + "The browser for " +
                            "the HTTPChannel's Load Context couldn't be " +
                            "found! " + result.error);
                    }
                }
            }
            return this._browser;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HttpChannelWrapper.prototype, "docShell", {
        get: function () {
            if (!this.hasOwnProperty("_docShell")) {
                var result = try_catch_utils_1.getDocShellFromHttpChannel(this._httpChannel);
                this._docShell = result.value;
                if (this._docShell === null) {
                    log_1.log.warn("The HTTPChannel's DocShell couldn't be found!", result.error);
                }
            }
            return this._docShell;
        },
        enumerable: true,
        configurable: true
    });
    return HttpChannelWrapper;
}());
exports.HttpChannelWrapper = HttpChannelWrapper;