"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var environment_1 = require("lib/environment");
var createPrefObserver = LegacyApi.createPrefObserver;
exports.ManagerForPrefObservers = (function () {
    var self = {};
    var observers = new Map();
    self.get = function (aEnv) {
        if (!(aEnv instanceof environment_1.Environment)) {
            return null;
        }
        if (observers.has(aEnv)) {
            return observers.get(aEnv);
        }
        var prefObserver = createPrefObserver();
        aEnv.addShutdownFunction(environment_1.Level.INTERFACE, function () {
            prefObserver.removeAllListeners();
        });
        observers.set(aEnv, prefObserver);
        return prefObserver;
    };
    return self;
})();