"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var util_js_1 = require("./util.js");
var _6_locales_currencies_tz_js_1 = require("./6.locales-currencies-tz.js");
function CanonicalizeLocaleList(locales) {
    if (locales === undefined)
        return new util_js_1.List();
    var seen = new util_js_1.List();
    locales = typeof locales === 'string' ? [locales] : locales;
    var O = util_js_1.toObject(locales);
    var len = util_js_1.toLength(O.length);
    var k = 0;
    while (k < len) {
        var Pk = String(k);
        var kPresent = Pk in O;
        if (kPresent) {
            var kValue = O[Pk];
            if (kValue === null || (typeof kValue !== 'string' && typeof kValue !== 'object'))
                throw new TypeError('String or Object type expected');
            var tag = String(kValue);
            if (!_6_locales_currencies_tz_js_1.IsStructurallyValidLanguageTag(tag))
                throw new RangeError("'" + tag + "' is not a structurally valid language tag");
            tag = _6_locales_currencies_tz_js_1.CanonicalizeLanguageTag(tag);
            if (util_js_1.arrIndexOf.call(seen, tag) === -1)
                util_js_1.arrPush.call(seen, tag);
        }
        k++;
    }
    return seen;
}
exports.CanonicalizeLocaleList = CanonicalizeLocaleList;