"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var extlang = '[a-z]{3}(?:-[a-z]{3}){0,2}';
var language = '(?:[a-z]{2,3}(?:-' + extlang + ')?|[a-z]{4}|[a-z]{5,8})';
var script = '[a-z]{4}';
var region = '(?:[a-z]{2}|\\d{3})';
var variant = '(?:[a-z0-9]{5,8}|\\d[a-z0-9]{3})';
var singleton = '[0-9a-wy-z]';
var extension = singleton + '(?:-[a-z0-9]{2,8})+';
var privateuse = 'x(?:-[a-z0-9]{1,8})+';
var irregular = '(?:en-GB-oed'
    + '|i-(?:ami|bnn|default|enochian|hak|klingon|lux|mingo|navajo|pwn|tao|tay|tsu)'
    + '|sgn-(?:BE-FR|BE-NL|CH-DE))';
var regular = '(?:art-lojban|cel-gaulish|no-bok|no-nyn'
    + '|zh-(?:guoyu|hakka|min|min-nan|xiang))';
var grandfathered = '(?:' + irregular + '|' + regular + ')';
var langtag = language + '(?:-' + script + ')?(?:-' + region + ')?(?:-'
    + variant + ')*(?:-' + extension + ')*(?:-' + privateuse + ')?';
exports.expBCP47Syntax = RegExp('^(?:' + langtag + '|' + privateuse + '|' + grandfathered + ')$', 'i');
exports.expVariantDupes = RegExp('^(?!x).*?-(' + variant + ')-(?:\\w{4,8}-(?!x-))*\\1\\b', 'i');
exports.expSingletonDupes = RegExp('^(?!x).*?-(' + singleton + ')-(?:\\w+-(?!x-))*\\1\\b', 'i');
exports.expExtSequences = RegExp('-' + extension, 'ig');