"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hop = Object.prototype.hasOwnProperty;
exports.defineProperty = Object.defineProperty;
exports.arrIndexOf = Array.prototype.indexOf || function (search) {
    var t = this;
    if (!t.length)
        return -1;
    for (var i = arguments[1] || 0, max = t.length; i < max; i++) {
        if (t[i] === search)
            return i;
    }
    return -1;
};
exports.objCreate = Object.create || function (proto, props) {
    var obj;
    function F() { }
    F.prototype = proto;
    obj = new F();
    for (var k in props) {
        if (exports.hop.call(props, k))
            exports.defineProperty(obj, k, props[k]);
    }
    return obj;
};
exports.arrSlice = Array.prototype.slice;
exports.arrPush = Array.prototype.push;
exports.arrJoin = Array.prototype.join;
function List() {
    exports.defineProperty(this, 'length', { writable: true, value: 0 });
    if (arguments.length)
        exports.arrPush.apply(this, exports.arrSlice.call(arguments));
}
exports.List = List;
List.prototype = exports.objCreate(null);
function toObject(arg) {
    if (arg === null)
        throw new TypeError('Cannot convert null or undefined to object');
    if (typeof arg === 'object')
        return arg;
    return Object(arg);
}
exports.toObject = toObject;
function toNumber(arg) {
    if (typeof arg === 'number')
        return arg;
    return Number(arg);
}
exports.toNumber = toNumber;
function toInteger(arg) {
    var number = toNumber(arg);
    if (isNaN(number))
        return 0;
    if (number === +0 ||
        number === -0 ||
        number === +Infinity ||
        number === -Infinity)
        return number;
    if (number < 0)
        return Math.floor(Math.abs(number)) * -1;
    return Math.floor(Math.abs(number));
}
exports.toInteger = toInteger;
function toLength(arg) {
    var len = toInteger(arg);
    if (len <= 0)
        return 0;
    if (len === Infinity)
        return Math.pow(2, 53) - 1;
    return Math.min(len, Math.pow(2, 53) - 1);
}
exports.toLength = toLength;