"use strict";
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequestReason = {
    UserPolicy: 1,
    SubscriptionPolicy: 2,
    DefaultPolicy: 3,
    DefaultPolicyInconsistentRules: 4,
    DefaultSameDomain: 5,
    Compatibility: 6,
    LinkClick: 7,
    FormSubmission: 8,
    HistoryRequest: 9,
    UserAllowedRedirect: 10,
    UserAction: 11,
    NewWindow: 12,
    IdenticalIdentifier: 13,
    RelativeUrl: 14,
};
var RequestResult = (function () {
    function RequestResult(isAllowed, resultReason) {
        this.isAllowed = isAllowed;
        this.resultReason = resultReason;
        this.matchedAllowRules = [];
        this.matchedDenyRules = [];
    }
    RequestResult.countOriginToDestRules = function (aMatchedRules) {
        var e_1, _a;
        var n = 0;
        try {
            for (var aMatchedRules_1 = __values(aMatchedRules), aMatchedRules_1_1 = aMatchedRules_1.next(); !aMatchedRules_1_1.done; aMatchedRules_1_1 = aMatchedRules_1.next()) {
                var _b = __read(aMatchedRules_1_1.value, 2), _c = __read(_b[1], 1), type = _c[0];
                if (type === "origin-to-dest")
                    ++n;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (aMatchedRules_1_1 && !aMatchedRules_1_1.done && (_a = aMatchedRules_1.return)) _a.call(aMatchedRules_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return n;
    };
    RequestResult.prototype.allowRulesExist = function () {
        return this.matchedAllowRules.length > 0;
    };
    RequestResult.prototype.denyRulesExist = function () {
        return this.matchedDenyRules.length > 0;
    };
    RequestResult.prototype.resolveConflict = function () {
        var nODAllowRules = RequestResult.
            countOriginToDestRules(this.matchedAllowRules);
        var nODDenyRules = RequestResult.
            countOriginToDestRules(this.matchedDenyRules);
        if (nODAllowRules === 0 && nODDenyRules > 0) {
            return { conflictCanBeResolved: true, shouldAllow: false };
        }
        if (nODAllowRules > 0 && nODDenyRules === 0) {
            return { conflictCanBeResolved: true, shouldAllow: true };
        }
        return { conflictCanBeResolved: false, shouldAllow: undefined };
    };
    RequestResult.prototype.isDefaultPolicyUsed = function () {
        return this.resultReason ===
            exports.RequestReason.DefaultPolicy ||
            this.resultReason ===
                exports.RequestReason.DefaultPolicyInconsistentRules ||
            this.resultReason === exports.RequestReason.DefaultSameDomain;
    };
    RequestResult.prototype.isOnBlacklist = function () {
        return this.isAllowed ? false : !this.isDefaultPolicyUsed();
    };
    return RequestResult;
}());
exports.RequestResult = RequestResult;