"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var app_background_1 = require("app/app.background");
var log_1 = require("app/log");
var constants_1 = require("data/constants");
function dprint(msg) {
    log_1.log.info("[POLICY] " + msg);
}
function dwarn(msg) {
    log_1.log.warn("[POLICY] " + msg);
}
var RuleAction;
(function (RuleAction) {
    RuleAction[RuleAction["ALLOW"] = constants_1.C.RULE_ACTION_ALLOW] = "ALLOW";
    RuleAction[RuleAction["DENY"] = constants_1.C.RULE_ACTION_DENY] = "DENY";
})(RuleAction || (RuleAction = {}));
var RawRuleset = (function () {
    function RawRuleset(aMetadata, aEntries) {
        this.metadata = aMetadata;
        this.entries = aEntries;
    }
    RawRuleset.create = function (aData) {
        var metadata = { version: 1 };
        var entries = {};
        if (aData) {
            var checkResult = RawRuleset.checkDataObj(aData);
            if (!checkResult.valid) {
                throw new Error("Invalid policy data: " + checkResult.error);
            }
            var data = aData;
            metadata = data.metadata;
            entries = data.entries;
        }
        if (!entries.allow) {
            entries.allow = [];
        }
        if (!entries.deny) {
            entries.deny = [];
        }
        return new RawRuleset(metadata, entries);
    };
    RawRuleset.checkDataObj = function (dataObj) {
        if (typeof dataObj !== "object") {
            return { valid: false, error: "not an object" };
        }
        if (!("metadata" in dataObj)) {
            return { valid: false, error: "no 'metadata' key" };
        }
        if (!("version" in dataObj.metadata)) {
            return { valid: false, error: "no 'version' key" };
        }
        if (dataObj.metadata.version !== 1) {
            return {
                error: "Wrong metadata version. " +
                    ("Expected 1, was " + dataObj.metadata.version),
                valid: false,
            };
        }
        if (!("entries" in dataObj)) {
            return { valid: false, error: "no 'entries' key" };
        }
        return { valid: true };
    };
    RawRuleset.prototype.toString = function () {
        return "[RawRuleset " + this.metadata + " " + this.entries + "]";
    };
    RawRuleset.prototype.getAllowRuleCount = function () {
        return this.entries.allow.length;
    };
    RawRuleset.prototype.getDenyRuleCount = function () {
        return this.entries.deny.length;
    };
    RawRuleset.prototype.ruleExists = function (ruleAction, ruleData) {
        var actionStr = ruleAction === RuleAction.ALLOW ? "allow" :
            ruleAction === RuleAction.DENY ? "deny" : "";
        if (!actionStr) {
            throw new Error("Invalid ruleAction: " + ruleAction);
        }
        var ruleStr = Ruleset.rawRuleToCanonicalString(ruleData);
        var entries = this.entries[actionStr];
        for (var i in entries) {
            var curRuleStr = Ruleset.rawRuleToCanonicalString(entries[i]);
            if (ruleStr === curRuleStr) {
                return true;
            }
        }
        return false;
    };
    RawRuleset.prototype.addRule = function (ruleAction, ruleData, policy) {
        var actionStr = ruleAction === RuleAction.ALLOW ? "allow" :
            ruleAction === RuleAction.DENY ? "deny" : "";
        if (!actionStr) {
            throw new Error("Invalid ruleAction: " + ruleAction);
        }
        if (!this.ruleExists(ruleAction, ruleData)) {
            this.entries[actionStr].push(ruleData);
        }
        if (policy) {
            this._addEntryToRuleset(ruleData, ruleAction, policy);
        }
    };
    RawRuleset.prototype.removeRule = function (ruleAction, ruleData, policy) {
        var actionStr = ruleAction === RuleAction.ALLOW ? "allow" :
            ruleAction === RuleAction.DENY ? "deny" : "";
        if (!actionStr) {
            throw new Error("Invalid ruleAction: " + ruleAction);
        }
        var ruleStr = Ruleset.rawRuleToCanonicalString(ruleData);
        var entries = this.entries[actionStr];
        var removeIndex = null;
        for (var i in entries) {
            var curRuleStr = Ruleset.rawRuleToCanonicalString(entries[i]);
            if (ruleStr === curRuleStr) {
                removeIndex = Number(i);
                break;
            }
        }
        if (removeIndex !== null) {
            var begin = entries.slice(0, removeIndex);
            var end = entries.slice(Number(removeIndex) + 1);
            if (begin.length + end.length + 1 !== entries.length) {
                throw new Error("Bad slicing (Probably bad math or not reading the docs).");
            }
            this.entries[actionStr] = begin.concat(end);
        }
        if (policy) {
            this._removeEntryFromRuleset(ruleData, ruleAction, policy);
        }
    };
    RawRuleset.prototype.toRuleset = function (name) {
        var policy = new Ruleset(name);
        for (var actionStr in this.entries) {
            if (actionStr !== "allow" && actionStr !== "deny") {
                dwarn("Invalid entry type: " + actionStr);
                continue;
            }
            var ruleAction = actionStr === "allow" ? RuleAction.ALLOW :
                RuleAction.DENY;
            var entryArray = this.entries[actionStr];
            for (var i in entryArray) {
                this._addEntryToRuleset(entryArray[i], ruleAction, policy);
            }
        }
        return policy;
    };
    RawRuleset.prototype._addEntryHelper = function (entryPart, policy) {
        var rules;
        if (entryPart.h) {
            rules = policy.addHost(entryPart.h).rules;
        }
        else {
            rules = policy.rules;
        }
        var r = rules.add("s" in entryPart ? entryPart.s : undefined, "port" in entryPart ? entryPart.port : undefined);
        if (entryPart.pathPre) {
            r.pathPre = entryPart.pathPre;
        }
        else if (entryPart.pathRegex) {
            r.pathRegex = new RegExp(entryPart.pathRegex);
        }
        return { rules: rules, r: r };
    };
    RawRuleset.prototype._addEntryToRuleset = function (entry, ruleAction, policy) {
        var _a, _b, _c, _d;
        var o = entry.o;
        var d = entry.d;
        var rules;
        var r;
        if (o && d) {
            (_a = this._addEntryHelper(o, policy), rules = _a.rules, r = _a.r);
            r.initDestinations();
            (_b = this._addEntryHelper(d, r.destinations), rules = _b.rules, r = _b.r);
            if (ruleAction === RuleAction.ALLOW) {
                r.allowDestination = true;
            }
            else {
                r.denyDestination = true;
            }
        }
        else if (o && !d) {
            (_c = this._addEntryHelper(o, policy), rules = _c.rules, r = _c.r);
            if (ruleAction === RuleAction.ALLOW) {
                r.allowOrigin = true;
            }
            else {
                r.denyOrigin = true;
            }
        }
        else if (!o && d) {
            (_d = this._addEntryHelper(d, policy), rules = _d.rules, r = _d.r);
            if (ruleAction === RuleAction.ALLOW) {
                r.allowDestination = true;
            }
            else {
                r.denyDestination = true;
            }
        }
        else {
            return;
        }
    };
    RawRuleset.prototype._removeEntryFromRuleset = function (entry, ruleAction, policy) {
        var o = entry.o;
        var d = entry.d;
        var rules;
        var r;
        if (o && d) {
            if (o.h) {
                var originEntry = policy.getHost(o.h);
                if (!originEntry) {
                    return;
                }
                rules = originEntry.rules;
            }
            else {
                rules = policy.rules;
            }
            r = rules.get(o.s, o.port);
            if (!r || !r.destinations) {
                return;
            }
            if (d.h) {
                var destEntry = r.destinations.getHost(d.h);
                if (!destEntry) {
                    return;
                }
                rules = destEntry.rules;
            }
            else {
                rules = r.destinations.rules;
            }
            r = rules.get(d.s, d.port);
            if (!r) {
                return;
            }
            if (ruleAction === RuleAction.ALLOW) {
                r.allowDestination = null;
            }
            else if (ruleAction === RuleAction.DENY) {
                r.denyDestination = null;
            }
            else {
                throw new Error("Invalid rule type: " + ruleAction);
            }
        }
        else if (o && !d) {
            if (o.h) {
                var originEntry = policy.getHost(o.h);
                if (!originEntry) {
                    return;
                }
                rules = originEntry.rules;
            }
            else {
                rules = policy.rules;
            }
            r = rules.get(o.s, o.port);
            if (!r) {
                return;
            }
            if (ruleAction === RuleAction.ALLOW) {
                r.allowOrigin = null;
            }
            else if (ruleAction === RuleAction.DENY) {
                r.denyOrigin = null;
            }
            else {
                throw new Error("Invalid rule type: " + ruleAction);
            }
        }
        else if (!o && d) {
            if (d.h) {
                var destEntry = policy.getHost(d.h);
                if (!destEntry) {
                    return;
                }
                rules = destEntry.rules;
            }
            else {
                rules = policy.rules;
            }
            r = rules.get(d.s, d.port);
            if (!r) {
                return;
            }
            if (ruleAction === RuleAction.ALLOW) {
                r.allowDestination = null;
            }
            else if (ruleAction === RuleAction.DENY) {
                r.denyDestination = null;
            }
            else {
                throw new Error("Invalid rule type: " + ruleAction);
            }
        }
        else {
            return;
        }
    };
    Object.defineProperty(RawRuleset.prototype, "raw", {
        get: function () {
            return { metadata: this.metadata, entries: this.entries };
        },
        enumerable: true,
        configurable: true
    });
    return RawRuleset;
}());
exports.RawRuleset = RawRuleset;
var Rules = (function () {
    function Rules() {
        this.rules = [];
    }
    Rules.prototype.print = function (depth) {
        if (depth === void 0) { depth = 0; }
        var e_1, _a;
        try {
            for (var _b = __values(this.rules), _c = _b.next(); !_c.done; _c = _b.next()) {
                var rule = _c.value;
                rule.print(depth);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    Rules.prototype.getRules = function () {
        return this.rules;
    };
    Rules.prototype.isEmpty = function () {
        return this.rules.length === 0;
    };
    Rules.prototype[Symbol.iterator] = function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [5, __values(this.rules)];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    };
    Rules.prototype.get = function (scheme, port) {
        var e_2, _a;
        var rule = new Rule(scheme, port);
        try {
            for (var _b = __values(this.rules), _c = _b.next(); !_c.done; _c = _b.next()) {
                var existingRule = _c.value;
                if (existingRule.isEqual(rule)) {
                    return existingRule;
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return null;
    };
    Rules.prototype.add = function (scheme, port) {
        var e_3, _a;
        var newRule = new Rule(scheme, port);
        try {
            for (var _b = __values(this.rules), _c = _b.next(); !_c.done; _c = _b.next()) {
                var existingRule = _c.value;
                if (existingRule.isEqual(newRule)) {
                    return existingRule;
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_3) throw e_3.error; }
        }
        this.rules.push(newRule);
        return newRule;
    };
    return Rules;
}());
var Rule = (function () {
    function Rule(scheme, port) {
        this.scheme = null;
        this.port = null;
        this.path = null;
        this.pathPre = null;
        this.pathRegex = null;
        this.allowOrigin = null;
        this.denyOrigin = null;
        this.allowDestination = null;
        this.denyDestination = null;
        if (scheme)
            this.scheme = scheme;
        if (port)
            this.port = port;
    }
    Rule.prototype.toString = function () {
        return "[Rule " + this.scheme + " " + this.port + " " + this.path + " " +
            "allowOrigin:" + this.allowOrigin + " " +
            "denyOrigin:" + this.denyOrigin + " " +
            "allowDestination:" + this.allowDestination + " " +
            "denyDestination:" + this.denyDestination + " " +
            "]";
    };
    Rule.prototype.print = function (depth) {
        depth = depth || 0;
        var indent = "";
        for (var i = 0; i < depth; i++) {
            indent += "  ";
        }
        dprint(indent + this.toString());
        if (this.destinations) {
            dprint(indent + "  " + "destinations:");
            this.destinations.print(depth + 1);
        }
    };
    Rule.prototype.isEqual = function (otherRule) {
        return this.scheme === otherRule.scheme &&
            this.port === otherRule.port &&
            this.path === otherRule.path;
    };
    Rule.prototype.initDestinations = function () {
        if (this.destinations) {
            return;
        }
        this.destinations = new Ruleset();
    };
    Rule.prototype.isMatch = function (uriObj, endpointSpecHasHost) {
        if (this.scheme && this.scheme !== "*" && this.scheme !== uriObj.scheme) {
            return false;
        }
        var uriService = app_background_1.rp.services.uri;
        if (uriService.uriObjHasPort(uriObj)) {
            if (this.port) {
                if (this.port !== "*") {
                    var rulePort = typeof this.port === "number" ? this.port :
                        parseInt(this.port, 10);
                    if (rulePort === uriObj.port ||
                        uriObj.port === -1 &&
                            rulePort === uriService.
                                getDefaultPortForScheme(uriObj.scheme)) {
                    }
                    else {
                        return false;
                    }
                }
            }
            else {
                if (!endpointSpecHasHost) {
                }
                else {
                    if (!uriService.hasStandardPort(uriObj)) {
                        return false;
                    }
                }
            }
        }
        else if (this.port) {
            return false;
        }
        if (this.path) {
            if (typeof this.path === "string") {
                if (uriObj.path.indexOf(this.path) !== 0) {
                    return false;
                }
            }
            else if (!this.path.test(uriObj.path)) {
                return false;
            }
        }
        return true;
    };
    return Rule;
}());
var DomainEntry = (function () {
    function DomainEntry(name, fullName, higher) {
        this.fullName = null;
        this.rules = new Rules();
        this.lower = {};
        if (typeof name !== "string" && name !== null) {
            throw new Error("Invalid type: DomainEntry name must be a string or null.");
        }
        if (name)
            this.name = name;
        if (fullName)
            this.fullName = fullName;
    }
    DomainEntry.prototype.toString = function () {
        return "[DomainEntry '" + this.name + " (" + this.fullName + ")']";
    };
    DomainEntry.prototype.print = function (depth) {
        depth = depth || 0;
        var indent = "";
        for (var i = 0; i < depth; i++) {
            indent += "  ";
        }
        dprint(indent + this.toString());
        if (this.rules) {
            this.rules.print(depth + 1);
        }
        for (var entryName in this.lower) {
            this.lower[entryName].print(depth + 1);
        }
    };
    DomainEntry.prototype.addLowerLevel = function (name, entry) {
        if (this.lower.hasOwnProperty(name)) {
            throw new Error("ENTRY_ALREADY_EXISTS");
        }
        this.lower[name] = entry;
    };
    DomainEntry.prototype.getLowerLevel = function (name) {
        if (this.lower.hasOwnProperty(name)) {
            return this.lower[name];
        }
        return null;
    };
    return DomainEntry;
}());
var IPAddressEntry = (function () {
    function IPAddressEntry(address) {
        this.rules = new Rules();
        this.address = address;
    }
    IPAddressEntry.prototype.toString = function () {
        return "[IPAddressEntry '" + this.address + "']";
    };
    IPAddressEntry.prototype.print = function (depth) {
        depth = depth || 0;
        var indent = "";
        for (var i = 0; i < depth; i++) {
            indent += "  ";
        }
        dprint(indent + this.toString());
        if (this.rules) {
            this.rules.print(depth + 1);
        }
    };
    return IPAddressEntry;
}());
var Ruleset = (function () {
    function Ruleset(name) {
        this.name = null;
        if (name)
            this.name = name;
        this.domain = new DomainEntry(null, null, null);
        this.ipAddr = {};
        this.rules = new Rules();
    }
    Ruleset.matchToRawRule = function (match) {
        var rawRule = {};
        var actionStr = match[0];
        if (actionStr === "origin") {
            var _a = __read(match, 3), entry = _a[1], rule = _a[2];
            Ruleset._matchToRawRuleHelper(rawRule, "o", entry, rule);
        }
        else if (actionStr === "dest") {
            var _b = __read(match, 3), entry = _b[1], rule = _b[2];
            Ruleset._matchToRawRuleHelper(rawRule, "d", entry, rule);
        }
        else if (actionStr === "origin-to-dest") {
            var _c = __read(match, 5), oEntry = _c[1], oRule = _c[2], dEntry = _c[3], dRule = _c[4];
            Ruleset._matchToRawRuleHelper(rawRule, "o", oEntry, oRule);
            Ruleset._matchToRawRuleHelper(rawRule, "d", dEntry, dRule);
        }
        else {
            throw new Error("[matchToRawRule] Invalid match type: " + actionStr +
                " from match: " + match);
        }
        return rawRule;
    };
    Ruleset.rawRuleToCanonicalString = function (rawRule) {
        var parts = ["{"];
        if (rawRule.d) {
            Ruleset._rawRuleToCanonicalStringHelper(rawRule, "d", parts);
        }
        if (rawRule.d && rawRule.o) {
            parts.push(",");
        }
        if (rawRule.o) {
            Ruleset._rawRuleToCanonicalStringHelper(rawRule, "o", parts);
        }
        parts.push("}");
        return parts.join("");
    };
    Ruleset._matchToRawRuleHelper = function (rawRule, originOrDest, entry, rule) {
        var endpointSpec = {};
        rawRule[originOrDest] = endpointSpec;
        if (entry instanceof DomainEntry && entry.fullName) {
            endpointSpec.h = entry.fullName;
        }
        else if (entry instanceof IPAddressEntry) {
            endpointSpec.h = entry.address;
        }
        if (rule.scheme) {
            endpointSpec.s = rule.scheme;
        }
        if (rule.port) {
            endpointSpec.port = rule.port;
        }
    };
    Ruleset._rawRuleToCanonicalStringHelper = function (rawRule, originOrDest, parts) {
        if (rawRule[originOrDest]) {
            var endpointSpec = rawRule[originOrDest];
            parts.push("\"" + originOrDest + "\":{");
            var needComma = false;
            if (endpointSpec.h) {
                parts.push("\"h\":\"" + endpointSpec.h + "\"");
                needComma = true;
            }
            if (endpointSpec.port) {
                if (needComma) {
                    parts.push(",");
                }
                parts.push("\"port\":\"" + endpointSpec.port + "\"");
            }
            if (endpointSpec.s) {
                if (needComma) {
                    parts.push(",");
                }
                parts.push("\"s\":\"" + endpointSpec.s + "\"");
            }
            parts.push("}");
        }
        parts.push("}");
        return parts.join("");
    };
    Ruleset.prototype.toString = function () {
        return "[Ruleset " + this.name + "]";
    };
    Ruleset.prototype.print = function (depth) {
        if (depth === void 0) { depth = 0; }
        var indent = "";
        for (var i = 0; i < depth; i++) {
            indent += "  ";
        }
        dprint(indent + this.toString());
        this.domain.print(depth + 1);
        this.rules.print(depth + 1);
    };
    Ruleset.prototype.getHost = function (host) {
        if (!host) {
            throw new Error("INVALID_HOST");
        }
        if (app_background_1.rp.services.uri.isIPAddress(host)) {
            return this._getIPAddress(host);
        }
        else {
            return this._getDomain(host);
        }
    };
    Ruleset.prototype.addHost = function (host) {
        if (!host) {
            throw new Error("INVALID_HOST");
        }
        if (app_background_1.rp.services.uri.isIPAddress(host)) {
            return this._addIPAddress(host);
        }
        else {
            return this._addDomain(host);
        }
    };
    Ruleset.prototype.getHostMatches = function (host) {
        var addrEntry, parts, curLevel, nextLevel, i;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!!this.rules.isEmpty()) return [3, 2];
                    return [4, [this, false]];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    if (!host) {
                        return [2];
                    }
                    if (!app_background_1.rp.services.uri.isIPAddress(host)) return [3, 5];
                    addrEntry = this.ipAddr[host];
                    if (!addrEntry) return [3, 4];
                    return [4, [addrEntry, true]];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4: return [3, 12];
                case 5:
                    parts = host.split(".");
                    curLevel = this.domain;
                    nextLevel = curLevel.getLowerLevel("*");
                    if (!nextLevel) return [3, 7];
                    return [4, [nextLevel, true]];
                case 6:
                    _a.sent();
                    _a.label = 7;
                case 7:
                    i = parts.length - 1;
                    _a.label = 8;
                case 8:
                    if (!(i >= 0)) return [3, 12];
                    nextLevel = curLevel.getLowerLevel(parts[i]);
                    if (!nextLevel) {
                        return [3, 12];
                    }
                    curLevel = nextLevel;
                    return [4, [nextLevel, true]];
                case 9:
                    _a.sent();
                    nextLevel = curLevel.getLowerLevel("*");
                    if (!nextLevel) return [3, 11];
                    return [4, [nextLevel, true]];
                case 10:
                    _a.sent();
                    _a.label = 11;
                case 11:
                    i--;
                    return [3, 8];
                case 12: return [2];
            }
        });
    };
    Ruleset.prototype.check = function (origin, dest) {
        var e_4, _a, e_5, _b, e_6, _c, e_7, _d, e_8, _e, e_9, _f;
        var matchedAllowRules = [];
        var matchedDenyRules = [];
        var uriService = app_background_1.rp.services.uri;
        var originHost = uriService.getHostByUriObj(origin) || "";
        var destHost = uriService.getHostByUriObj(dest) || "";
        try {
            for (var _g = __values(this.getHostMatches(originHost)), _h = _g.next(); !_h.done; _h = _g.next()) {
                var _j = __read(_h.value, 2), entry = _j[0], originSpecHasHost = _j[1];
                try {
                    for (var _k = __values(entry.rules), _l = _k.next(); !_l.done; _l = _k.next()) {
                        var rule = _l.value;
                        var ruleMatchedOrigin = rule.isMatch(origin, originSpecHasHost);
                        if (rule.allowOrigin && ruleMatchedOrigin) {
                            matchedAllowRules.push(["origin", entry, rule]);
                        }
                        if (rule.denyOrigin && ruleMatchedOrigin) {
                            matchedDenyRules.push(["origin", entry, rule]);
                        }
                        if (ruleMatchedOrigin && rule.destinations) {
                            try {
                                for (var _m = __values(rule.destinations.getHostMatches(destHost)), _o = _m.next(); !_o.done; _o = _m.next()) {
                                    var _p = __read(_o.value, 2), destEntry = _p[0], destSpecHasHost = _p[1];
                                    try {
                                        for (var _q = __values(destEntry.rules), _r = _q.next(); !_r.done; _r = _q.next()) {
                                            var destRule = _r.value;
                                            if (destRule.allowDestination &&
                                                destRule.isMatch(dest, destSpecHasHost)) {
                                                matchedAllowRules.push([
                                                    "origin-to-dest",
                                                    entry,
                                                    rule,
                                                    destEntry,
                                                    destRule,
                                                ]);
                                            }
                                            if (destRule.denyDestination &&
                                                destRule.isMatch(dest, destSpecHasHost)) {
                                                matchedDenyRules.push([
                                                    "origin-to-dest",
                                                    entry,
                                                    rule,
                                                    destEntry,
                                                    destRule,
                                                ]);
                                            }
                                        }
                                    }
                                    catch (e_7_1) { e_7 = { error: e_7_1 }; }
                                    finally {
                                        try {
                                            if (_r && !_r.done && (_d = _q.return)) _d.call(_q);
                                        }
                                        finally { if (e_7) throw e_7.error; }
                                    }
                                }
                            }
                            catch (e_6_1) { e_6 = { error: e_6_1 }; }
                            finally {
                                try {
                                    if (_o && !_o.done && (_c = _m.return)) _c.call(_m);
                                }
                                finally { if (e_6) throw e_6.error; }
                            }
                        }
                    }
                }
                catch (e_5_1) { e_5 = { error: e_5_1 }; }
                finally {
                    try {
                        if (_l && !_l.done && (_b = _k.return)) _b.call(_k);
                    }
                    finally { if (e_5) throw e_5.error; }
                }
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_h && !_h.done && (_a = _g.return)) _a.call(_g);
            }
            finally { if (e_4) throw e_4.error; }
        }
        try {
            for (var _s = __values(this.getHostMatches(destHost)), _t = _s.next(); !_t.done; _t = _s.next()) {
                var _u = __read(_t.value, 2), entry = _u[0], destSpecHasHost = _u[1];
                try {
                    for (var _v = __values(entry.rules), _w = _v.next(); !_w.done; _w = _v.next()) {
                        var rule = _w.value;
                        if (rule.allowDestination && rule.isMatch(dest, destSpecHasHost)) {
                            matchedAllowRules.push(["dest", entry, rule]);
                        }
                        if (rule.denyDestination && rule.isMatch(dest, destSpecHasHost)) {
                            matchedDenyRules.push(["dest", entry, rule]);
                        }
                    }
                }
                catch (e_9_1) { e_9 = { error: e_9_1 }; }
                finally {
                    try {
                        if (_w && !_w.done && (_f = _v.return)) _f.call(_v);
                    }
                    finally { if (e_9) throw e_9.error; }
                }
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (_t && !_t.done && (_e = _s.return)) _e.call(_s);
            }
            finally { if (e_8) throw e_8.error; }
        }
        return [matchedAllowRules, matchedDenyRules];
    };
    Ruleset.prototype._getIPAddress = function (address) {
        return this.ipAddr[address];
    };
    Ruleset.prototype._addIPAddress = function (address) {
        if (!this.ipAddr[address]) {
            this.ipAddr[address] = new IPAddressEntry(address);
        }
        return this.ipAddr[address];
    };
    Ruleset.prototype._getDomain = function (domain) {
        var parts = domain.split(".");
        var curLevel = this.domain;
        var nextLevel;
        var fullName = "";
        for (var i = parts.length - 1; i >= 0; i--) {
            fullName = parts[i] + (fullName ? "." : "") + fullName;
            nextLevel = curLevel.getLowerLevel(parts[i]);
            if (!nextLevel) {
                return null;
            }
            curLevel = nextLevel;
        }
        return curLevel;
    };
    Ruleset.prototype._addDomain = function (domain) {
        var parts = domain.split(".");
        var curLevel = this.domain;
        var nextLevel;
        var fullName = "";
        for (var i = parts.length - 1; i >= 0; i--) {
            fullName = parts[i] + (fullName ? "." : "") + fullName;
            nextLevel = curLevel.getLowerLevel(parts[i]);
            if (!nextLevel) {
                nextLevel = new DomainEntry(parts[i], fullName, curLevel);
                curLevel.addLowerLevel(parts[i], nextLevel);
            }
            curLevel = nextLevel;
        }
        return curLevel;
    };
    return Ruleset;
}());
exports.Ruleset = Ruleset;