"use strict";
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
function removeChildren(aElements) {
    var e_1, _a;
    var elements = Array.isArray(aElements) ? aElements : [aElements];
    try {
        for (var elements_1 = __values(elements), elements_1_1 = elements_1.next(); !elements_1_1.done; elements_1_1 = elements_1.next()) {
            var el = elements_1_1.value;
            while (el.firstChild) {
                el.removeChild(el.firstChild);
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (elements_1_1 && !elements_1_1.done && (_a = elements_1.return)) _a.call(elements_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
}
exports.removeChildren = removeChildren;
function isThisElementVisible(aElement) {
    if (!aElement || !aElement.getClientRects) {
        return false;
    }
    var rects = aElement.getClientRects();
    if (rects.length === 0) {
        return false;
    }
    var rect = rects[0];
    return rect.width > 0 && rect.height > 0;
}
function isElementVisible(aElement) {
    if (!isThisElementVisible(aElement)) {
        return false;
    }
    var parent = aElement.parentElement;
    return parent !== null ? isElementVisible(parent) : true;
}
exports.isElementVisible = isElementVisible;