"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function parseRefresh(refreshString) {
    var parts = /^\s*(\S*?)\s*(;\s*url\s*=\s*(.*?)\s*)?$/i.exec(refreshString);
    if (parts === null) {
        throw new Error("parseRefresh regex did not match");
    }
    var delay = parseFloat(parts[1]);
    if (isNaN(delay)) {
        throw new Error("Invalid delay value in refresh string: " + parts[1]);
    }
    var url = parts[3];
    if (url === undefined) {
        url = "";
    }
    if (url) {
        var first = url[0];
        var last = url[url.length - 1];
        if (first === last && (first === "'" || first === "\"")) {
            url = url.substring(1, url.length - 1);
        }
    }
    return { delay: delay, destURI: url };
}
exports.parseRefresh = parseRefresh;