"use strict";
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
function arrayIncludes(array, searchElement) {
    var e_1, _a;
    try {
        for (var array_1 = __values(array), array_1_1 = array_1.next(); !array_1_1.done; array_1_1 = array_1.next()) {
            var element = array_1_1.value;
            if (element === searchElement) {
                return true;
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (array_1_1 && !array_1_1.done && (_a = array_1.return)) _a.call(array_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return false;
}
exports.arrayIncludes = arrayIncludes;
var PromiseState;
(function (PromiseState) {
    PromiseState["pending"] = "pending";
    PromiseState["fulfilled"] = "fulfilled";
    PromiseState["rejected"] = "rejected";
})(PromiseState || (PromiseState = {}));
function defer() {
    var promiseState = PromiseState.pending;
    var rejectFn;
    var resolveFn;
    var promise = new Promise(function (aResolveFn, aRejectFn) {
        rejectFn = aRejectFn;
        resolveFn = aResolveFn;
    });
    function reject(value) {
        promiseState = PromiseState.rejected;
        rejectFn(value);
    }
    function resolve(value) {
        promiseState = PromiseState.fulfilled;
        resolveFn(value);
    }
    return {
        promise: promise,
        get promiseState() {
            return promiseState;
        },
        reject: reject,
        resolve: resolve,
    };
}
exports.defer = defer;
function createLazyGetter(aKey, aValueFn) {
    return function () {
        delete this[aKey];
        var value = aValueFn.call(this);
        Object.defineProperty(this, aKey, {
            configurable: true,
            enumerable: true,
            value: value,
            writable: true,
        });
        return value;
    };
}
exports.createLazyGetter = createLazyGetter;
function defineLazyGetter(aOnObj, aKey, aValueFn) {
    Object.defineProperty(aOnObj, aKey, {
        configurable: true,
        enumerable: true,
        get: createLazyGetter(aKey, aValueFn),
    });
}
exports.defineLazyGetter = defineLazyGetter;
function isThenable(aObj) {
    if (!aObj)
        return false;
    if (typeof aObj !== "object")
        return false;
    return typeof aObj.then === "function";
}
exports.isThenable = isThenable;
function leftRotateArray(array, n) {
    n = n % array.length;
    var firstPart = array.slice(0, n);
    var secondPart = array.slice(n);
    return secondPart.concat(firstPart);
}
exports.leftRotateArray = leftRotateArray;
function objectEntries(obj) {
    var keys = Object.keys(obj);
    var i = keys.length;
    var resArray = new Array(i);
    while (i--)
        resArray[i] = [keys[i], obj[keys[i]]];
    return resArray;
}
exports.objectEntries = objectEntries;
function objectValues(obj) {
    var keys = Object.keys(obj);
    var i = keys.length;
    var resArray = new Array(i);
    while (i--)
        resArray[i] = keys[i];
    return resArray;
}
exports.objectValues = objectValues;
function range(n) {
    var array = [];
    for (var i = 0; i < n; i++) {
        array.push(i);
    }
    return array;
}
exports.range = range;