"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var listeners_1 = require("lib/classes/listeners");
var map_of_custom_sets_1 = require("lib/classes/map-of-custom-sets");
function createListenersMap(aEventNames, _a) {
    var _b = _a === void 0 ? {
        assignInterfacesTo: {},
        assignListenersTo: {},
    } : _a, _c = _b.assignInterfacesTo, interfaces = _c === void 0 ? {} : _c, _d = _b.assignListenersTo, listenersMap = _d === void 0 ? {} : _d;
    var eventNames = Array.isArray(aEventNames) ? aEventNames : [aEventNames];
    eventNames.forEach(function (eventName) {
        var eventListeners = new listeners_1.Listeners();
        listenersMap[eventName] = eventListeners;
        interfaces[eventName] = eventListeners.interface;
    });
    return { listenersMap: listenersMap, interfaces: interfaces };
}
exports.createListenersMap = createListenersMap;
function createMapOfListeners() {
    return new map_of_custom_sets_1.MapOfCustomSets(function () { return new listeners_1.Listeners(); });
}
exports.createMapOfListeners = createMapOfListeners;