"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function endpointSpecToDisplayString(aEndpointSpec) {
    if (aEndpointSpec.port !== undefined &&
        (aEndpointSpec.h === null || aEndpointSpec.h === "")) {
        return "[invalid endpoint specification]";
    }
    var scheme = aEndpointSpec.s ? String(aEndpointSpec.s) : "*";
    if (aEndpointSpec.port === undefined) {
        switch (aEndpointSpec.h) {
            case undefined:
                if (aEndpointSpec.s === undefined) {
                    return "";
                }
                return scheme + ":<path> (host optional)";
            case null:
                return scheme + ":<path> (no host)";
            case "":
                return scheme + "://<path> (empty host)";
            default:
                break;
        }
    }
    var str = "";
    if (scheme !== "*" || aEndpointSpec.port) {
        str += scheme + "://";
    }
    str += aEndpointSpec.h || "*";
    if (aEndpointSpec.port) {
        str += ":" + aEndpointSpec.port;
    }
    return str;
}
exports.endpointSpecToDisplayString = endpointSpecToDisplayString;