"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var WindowUtils = require("lib/utils/window-utils");
var value = function (val) { return ({ value: val }); };
var error = function (err) { return ({ error: err, value: null }); };
function queryInterface(object, interf) {
    try {
        return value(object.QueryInterface(interf));
    }
    catch (e) {
        return error(e);
    }
}
exports.queryInterface = queryInterface;
function getDocShellFromHttpChannel(httpChannel) {
    try {
        return value(httpChannel.notificationCallbacks.
            QueryInterface(Ci.nsIInterfaceRequestor).
            getInterface(Ci.nsIDocShell));
    }
    catch (e) {
        return error(e);
    }
}
exports.getDocShellFromHttpChannel = getDocShellFromHttpChannel;
function getLoadContextFromHttpChannel(httpChannel) {
    try {
        return value(httpChannel.notificationCallbacks.
            QueryInterface(Ci.nsIInterfaceRequestor).
            getInterface(Ci.nsILoadContext));
    }
    catch (ex) {
        try {
            return value(httpChannel.loadGroup.notificationCallbacks.
                getInterface(Ci.nsILoadContext));
        }
        catch (ex2) {
            return error(ex2);
        }
    }
}
exports.getLoadContextFromHttpChannel = getLoadContextFromHttpChannel;
function getRequestHeaderFromHttpChannel(httpChannel, header) {
    try {
        return value(httpChannel.getRequestHeader("X-moz"));
    }
    catch (e) {
        return error(e);
    }
}
exports.getRequestHeaderFromHttpChannel = getRequestHeaderFromHttpChannel;
var try_catch_utils_mpl_1 = require("./try-catch-utils.mpl");
exports.getAppLocale = try_catch_utils_mpl_1.getAppLocale;
function getBrowserFromLoadContext(loadContext) {
    try {
        if (loadContext.topFrameElement) {
            return value(loadContext.topFrameElement);
        }
        else {
            return value(WindowUtils.getBrowserForWindow(loadContext.topWindow));
        }
    }
    catch (e) {
        return error(e);
    }
}
exports.getBrowserFromLoadContext = getBrowserFromLoadContext;
function addSessionHistoryListener(gBrowser, listener) {
    try {
        gBrowser.webNavigation.sessionHistory.addSHistoryListener(listener);
        return value(null);
    }
    catch (e) {
        return error(e);
    }
}
exports.addSessionHistoryListener = addSessionHistoryListener;
function removeSessionHistoryListener(gBrowser, listener) {
    try {
        gBrowser.webNavigation.sessionHistory.removeSHistoryListener(listener);
        return value(null);
    }
    catch (e) {
        return error(e);
    }
}
exports.removeSessionHistoryListener = removeSessionHistoryListener;