"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var PREF_MATCH_OS_LOCALE = "intl.locale.matchOS";
var PREF_SELECTED_LOCALE = "general.useragent.locale";
function getAppLocale(prefsService, localeService) {
    try {
        if (prefsService.getBoolPref(PREF_MATCH_OS_LOCALE)) {
            return localeService.getLocaleComponentForUserAgent();
        }
    }
    catch (e) { }
    try {
        var locale = prefsService.getComplexValue(PREF_SELECTED_LOCALE, Ci.nsIPrefLocalizedString);
        if (locale)
            return locale.data;
    }
    catch (e) { }
    try {
        return prefsService.getCharPref(PREF_SELECTED_LOCALE);
    }
    catch (e) { }
    return "en-US";
}
exports.getAppLocale = getAppLocale;