"use strict";
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var PrivateBrowsingUtils = Cu.import("resource://gre/modules/PrivateBrowsingUtils.jsm", {}).PrivateBrowsingUtils;
function getMostRecentWindow(aWindowType) {
    if (aWindowType === void 0) { aWindowType = null; }
    return Services.wm.getMostRecentWindow(aWindowType);
}
exports.getMostRecentWindow = getMostRecentWindow;
exports.getMostRecentBrowserWindow = getMostRecentWindow.bind(null, "navigator:browser");
function getChromeWindow(aContentWindow) {
    return aContentWindow.top.QueryInterface(Ci.nsIInterfaceRequestor).
        getInterface(Ci.nsIWebNavigation).
        QueryInterface(Ci.nsIDocShellTreeItem).
        rootTreeItem.
        QueryInterface(Ci.nsIInterfaceRequestor).
        getInterface(Ci.nsIDOMWindow);
}
exports.getChromeWindow = getChromeWindow;
function getBrowserForWindow(aContentWindow) {
    var e_1, _a;
    var win = getChromeWindow(aContentWindow);
    var tabs = getTabsForWindow(win);
    try {
        for (var tabs_1 = __values(tabs), tabs_1_1 = tabs_1.next(); !tabs_1_1.done; tabs_1_1 = tabs_1.next()) {
            var tab = tabs_1_1.value;
            if (tab.linkedBrowser.contentWindow === aContentWindow.top) {
                return tab.linkedBrowser;
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (tabs_1_1 && !tabs_1_1.done && (_a = tabs_1.return)) _a.call(tabs_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return null;
}
exports.getBrowserForWindow = getBrowserForWindow;
function getChromeWindowForDocShell(aDocShell) {
    return aDocShell.QueryInterface(Ci.nsIDocShellTreeItem).
        rootTreeItem.
        QueryInterface(Ci.nsIInterfaceRequestor).
        getInterface(Ci.nsIDOMWindow);
}
exports.getChromeWindowForDocShell = getChromeWindowForDocShell;
function getTabBrowser(aChromeWindow) {
    return aChromeWindow.gBrowser || aChromeWindow.getBrowser();
}
exports.getTabBrowser = getTabBrowser;
function getTabsForWindow(aChromeWindow) {
    return getTabBrowser(aChromeWindow).tabContainer.children;
}
exports.getTabsForWindow = getTabsForWindow;
function isWindowPrivate(aWindow) {
    return PrivateBrowsingUtils.isWindowPrivate(aWindow);
}
exports.isWindowPrivate = isWindowPrivate;
function mayPermanentRulesBeAdded(aWindow, storage) {
    return isWindowPrivate(aWindow) === false ||
        storage.get("privateBrowsingPermanentWhitelisting");
}
exports.mayPermanentRulesBeAdded = mayPermanentRulesBeAdded;
function getElementsByIdOnLoad(aWindow, aElementIDs, aScope, aCallback) {
    var scope = aScope || {};
    var document = aWindow.document;
    var callback = function () {
        aWindow.removeEventListener("load", callback);
        for (var elementName in aElementIDs) {
            scope[elementName] = document.getElementById(aElementIDs[elementName]);
        }
        if (aCallback) {
            aCallback();
        }
    };
    aWindow.addEventListener("load", callback);
    return scope;
}
exports.getElementsByIdOnLoad = getElementsByIdOnLoad;