"use strict";
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var app_background_1 = require("app/app.background");
var requests_1 = require("models/requests");
var uriService = app_background_1.rp.services.uri;
var cachedSettings = app_background_1.rp.storage.cachedSettings;
var initFunctions = [];
exports.FramescriptServices = {
    init: function () {
        var e_1, _a;
        try {
            for (var initFunctions_1 = __values(initFunctions), initFunctions_1_1 = initFunctions_1.next(); !initFunctions_1_1.done; initFunctions_1_1 = initFunctions_1.next()) {
                var fn = initFunctions_1_1.value;
                fn();
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (initFunctions_1_1 && !initFunctions_1_1.done && (_a = initFunctions_1.return)) _a.call(initFunctions_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    },
};
(function () {
    var messageListeners = {};
    function containsNonBlacklistedRequests(aRequests) {
        for (var i = 0, len = aRequests.length; i < len; i++) {
            if (!aRequests[i].isOnBlacklist()) {
                return true;
            }
        }
        return false;
    }
    messageListeners.notifyDocumentLoaded = function (aMessage, aSender, aSendResponse) {
        var documentURI = aMessage.documentURI;
        var originURI = uriService.getUriObject(documentURI).specIgnoringRef;
        var blockedURIs = {};
        if (cachedSettings.get("indicateBlockedObjects")) {
            var indicateBlacklisted = cachedSettings.get("indicateBlacklistedObjects");
            var rejectedRequests = requests_1.Requests._requestSets.rejectedRequests.
                getOriginUri(originURI);
            for (var destBase in rejectedRequests) {
                for (var destIdent in rejectedRequests[destBase]) {
                    for (var destUri in rejectedRequests[destBase][destIdent]) {
                        var requests = rejectedRequests[destBase][destIdent][destUri];
                        if (indicateBlacklisted ||
                            containsNonBlacklistedRequests(requests)) {
                            blockedURIs[destUri] = blockedURIs[destUri] ||
                                { identifier: uriService.getIdentifier(destUri) };
                        }
                    }
                }
            }
        }
        aSendResponse({ blockedURIs: blockedURIs });
    };
    function onMessage(aMessage, aSender, aSendResponse) {
        if (typeof aMessage.type === "undefined") {
            return;
        }
        if (typeof messageListeners[aMessage.type] === "undefined") {
            return;
        }
        return messageListeners[aMessage.type].
            call(null, aMessage, aSender, aSendResponse);
    }
    initFunctions.push(function () {
        browser.runtime.onMessage.addListener(onMessage);
    });
})();