"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var set_1 = require("lib/classes/set");
var listener_factories_1 = require("lib/utils/listener-factories");
var WindowUtils = require("lib/utils/window-utils");
var NotificationID;
(function (NotificationID) {
    NotificationID[NotificationID["InitialSetup"] = 0] = "InitialSetup";
    NotificationID[NotificationID["MultipleRPInstallations"] = 1] = "MultipleRPInstallations";
})(NotificationID = exports.NotificationID || (exports.NotificationID = {}));
var URI_MAP = new Map([
    [
        NotificationID.InitialSetup,
        "about:requestpolicy?setup",
    ],
    [
        NotificationID.MultipleRPInstallations,
        "chrome://rpcontinued/content/multiple-installations.html",
    ],
]);
var NotificationsClass = (function (_super) {
    __extends(NotificationsClass, _super);
    function NotificationsClass() {
        var _this = _super.call(this) || this;
        _this.eventListenersMap = listener_factories_1.createListenersMap([
            "onAdded",
            "onDeleted",
            "onTabOpened",
        ]).listenersMap;
        _this.onAdded = _this.eventListenersMap.onAdded.interface;
        _this.onDeleted = _this.eventListenersMap.onDeleted.interface;
        _this.onTabOpened = _this.eventListenersMap.onTabOpened.interface;
        return _this;
    }
    NotificationsClass.prototype.add = function (aID) {
        if (this.has(aID))
            return this;
        _super.prototype.add.call(this, aID);
        this.eventListenersMap.onAdded.emit(aID);
        return this;
    };
    NotificationsClass.prototype.delete = function (aID) {
        if (!this.has(aID))
            return false;
        this.delete(aID);
        this.eventListenersMap.onDeleted.emit(aID);
        return true;
    };
    NotificationsClass.prototype.openTab = function (aID) {
        var win = WindowUtils.getMostRecentBrowserWindow();
        var tabbrowser = win.getBrowser();
        tabbrowser.selectedTab = tabbrowser.addTab(URI_MAP.get(aID));
        this.eventListenersMap.onTabOpened.emit(aID);
    };
    return NotificationsClass;
}(set_1.OverridableSet));
exports.Notifications = new NotificationsClass();