"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var xpcom_utils_1 = require("legacy/lib/utils/xpcom-utils");
var WindowUtils = require("lib/utils/window-utils");
var windows_1 = require("models/windows");
function areWindowsAvailable() {
    if (WindowUtils.getMostRecentBrowserWindow() === null) {
        return false;
    }
    try {
        windows_1.Windows.forEachOpenWindow(function (win) { return WindowUtils.getTabBrowser(win); });
    }
    catch (e) {
        return false;
    }
    return true;
}
function promiseSessionstoreWindowsRestored() {
    return xpcom_utils_1.promiseObserverTopic("sessionstore-windows-restored").
        then(function () { return undefined; });
}
exports.pWindowsAvailable = areWindowsAvailable() ? Promise.resolve() :
    promiseSessionstoreWindowsRestored();