"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("./common");
(function () {
    var _a = browser.extension.getBackgroundPage(), ManagerForPrefObservers = _a.ManagerForPrefObservers, rp = _a.rp;
    var cachedSettings = rp.storage.cachedSettings;
    function updateDisplay() {
        common_1.$id("pref-browserSettings.disablePrefetching").checked =
            cachedSettings.get("browserSettings.disablePrefetching");
        var sorting = cachedSettings.get("menu.sorting");
        if (sorting === common_1.$id("sortByNumRequests").value) {
            common_1.$id("sortByNumRequests").checked = true;
            common_1.$id("sortByDestName").checked = false;
            common_1.$id("noSorting").checked = false;
        }
        else if (sorting === common_1.$id("noSorting").value) {
            common_1.$id("sortByNumRequests").checked = false;
            common_1.$id("sortByDestName").checked = false;
            common_1.$id("noSorting").checked = true;
        }
        else {
            common_1.$id("sortByNumRequests").checked = false;
            common_1.$id("sortByDestName").checked = true;
            common_1.$id("noSorting").checked = false;
        }
        common_1.$id("menu.info.showNumRequests").checked =
            cachedSettings.get("menu.info.showNumRequests");
    }
    window.onload = function () {
        updateDisplay();
        common_1.elManager.addListener(common_1.$id("pref-browserSettings.disablePrefetching"), "change", function (event) {
            cachedSettings.set({
                "browserSettings.disablePrefetching": event.target.checked,
            });
        });
        var sortingListener = function (event) {
            cachedSettings.set({ "menu.sorting": event.target.value });
        };
        common_1.elManager.addListener(common_1.$id("sortByNumRequests"), "change", sortingListener);
        common_1.elManager.addListener(common_1.$id("sortByDestName"), "change", sortingListener);
        common_1.elManager.addListener(common_1.$id("noSorting"), "change", sortingListener);
        common_1.elManager.addListener(common_1.$id("menu.info.showNumRequests"), "change", function (event) {
            cachedSettings.set({
                "menu.info.showNumRequests": event.target.checked,
            });
        });
        ManagerForPrefObservers.get(common_1.WinEnv).addListeners([
            "",
        ], updateDisplay);
    };
})();