"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("./common");
(function () {
    var _a = browser.extension.getBackgroundPage(), ManagerForPrefObservers = _a.ManagerForPrefObservers, rp = _a.rp;
    var cachedSettings = rp.storage.cachedSettings;
    function updateDisplay() {
        var indicate = cachedSettings.get("indicateBlockedObjects");
        common_1.$id("pref-indicateBlockedObjects").checked = indicate;
        common_1.$id("indicateBlockedImages-details").hidden = !indicate;
        common_1.$id("pref-dontIndicateBlacklistedObjects").checked =
            !cachedSettings.get("indicateBlacklistedObjects");
        common_1.$id("pref-autoReload").checked =
            cachedSettings.get("autoReload");
        common_1.$id("pref-privateBrowsingPermanentWhitelisting").checked =
            cachedSettings.get("privateBrowsingPermanentWhitelisting");
    }
    window.onload = function () {
        updateDisplay();
        common_1.elManager.addListener(common_1.$id("pref-indicateBlockedObjects"), "change", function (event) {
            cachedSettings.set({
                "indicateBlockedObjects": event.target.checked,
            });
            updateDisplay();
        });
        common_1.elManager.addListener(common_1.$id("pref-dontIndicateBlacklistedObjects"), "change", function (event) {
            cachedSettings.set({
                "indicateBlacklistedObjects": !event.target.checked,
            });
            updateDisplay();
        });
        common_1.elManager.addListener(common_1.$id("pref-autoReload"), "change", function (event) {
            cachedSettings.set({ "autoReload": event.target.checked });
            updateDisplay();
        });
        common_1.elManager.addListener(common_1.$id("pref-privateBrowsingPermanentWhitelisting"), "change", function (event) {
            cachedSettings.set({
                "privateBrowsingPermanentWhitelisting": event.target.checked,
            });
            updateDisplay();
        });
        ManagerForPrefObservers.get(common_1.WinEnv).addListener("", updateDisplay);
    };
})();