"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("./common");
(function () {
    var _a = browser.extension.getBackgroundPage(), ManagerForPrefObservers = _a.ManagerForPrefObservers, rp = _a.rp;
    var cachedSettings = rp.storage.cachedSettings;
    function updateDisplay() {
        var defaultallow = cachedSettings.get("defaultPolicy.allow");
        if (defaultallow) {
            common_1.$id("defaultallow").checked = true;
            common_1.$id("defaultdenysetting").hidden = true;
        }
        else {
            common_1.$id("defaultdeny").checked = true;
            common_1.$id("defaultdenysetting").hidden = false;
        }
        var allowsamedomain = cachedSettings.get("defaultPolicy.allowSameDomain");
        common_1.$id("allowsamedomain").checked = allowsamedomain;
        var allowTopLevel = cachedSettings.get("defaultPolicy.allowTopLevel");
        common_1.$id("allowtoplevel").checked = allowTopLevel;
    }
    function showManageSubscriptionsLink() {
        common_1.$id("subscriptionschanged").style.display = "block";
    }
    window.onload = function () {
        updateDisplay();
        common_1.elManager.addListener(common_1.$id("defaultallow"), "change", function (event) {
            var allow = event.target.checked;
            cachedSettings.set({ "defaultPolicy.allow": allow });
            updateDisplay();
            showManageSubscriptionsLink();
        });
        common_1.elManager.addListener(common_1.$id("defaultdeny"), "change", function (event) {
            var deny = event.target.checked;
            cachedSettings.set({ "defaultPolicy.allow": !deny });
            updateDisplay();
            showManageSubscriptionsLink();
        });
        common_1.elManager.addListener(common_1.$id("allowsamedomain"), "change", function (event) {
            var allowSameDomain = event.target.checked;
            cachedSettings.set({
                "defaultPolicy.allowSameDomain": allowSameDomain,
            });
        });
        common_1.elManager.addListener(common_1.$id("allowtoplevel"), "change", function (event) {
            var allowTopLevel = event.target.checked;
            cachedSettings.set({
                "defaultPolicy.allowTopLevel": allowTopLevel,
            });
        });
        ManagerForPrefObservers.get(common_1.WinEnv).addListener("", updateDisplay);
    };
})();