(function () {
    var _a = browser.extension.getBackgroundPage(), Metadata = _a.Metadata, Requests = _a.Requests;
    function getNRequestResultObjects(aRequestSet) {
        var n = 0;
        var origins = aRequestSet._origins;
        for (var originURI in origins) {
            var originUriRequests = origins[originURI];
            for (var destBase in originUriRequests) {
                var destBaseRequests = originUriRequests[destBase];
                for (var destIdent in destBaseRequests) {
                    var destIdentRequests = destBaseRequests[destIdent];
                    for (var destURI in destIdentRequests) {
                        var destUriRequests = destIdentRequests[destURI];
                        n += Object.getOwnPropertyNames(destUriRequests).length;
                    }
                }
            }
        }
        return n;
    }
    function getMemoryInfo() {
        var nRRAllowed = getNRequestResultObjects(Requests._requestSets.allowedRequests);
        var nRRDenied = getNRequestResultObjects(Requests._requestSets.rejectedRequests);
        return {
            nRRAllowed: nRRAllowed,
            nRRDenied: nRRDenied,
            nRRTotal: nRRAllowed + nRRDenied,
            nClickedLinks: Object.
                getOwnPropertyNames(Metadata.ClickedLinks).length,
            nFaviconRequests: Object.
                getOwnPropertyNames(Metadata.FaviconRequests).length,
        };
    }
    function deleteOwnProperties(obj) {
        for (var key in obj) {
            if (obj.hasOwnProperty(key)) {
                delete obj[key];
            }
        }
    }
    function freeMemory() {
        var memoryInfo = getMemoryInfo();
        deleteOwnProperties(Requests._requestSets.allowedRequests._origins);
        deleteOwnProperties(Requests._requestSets.rejectedRequests._origins);
        deleteOwnProperties(Metadata.ClickedLinks);
        deleteOwnProperties(Metadata.ClickedLinksReverse);
        deleteOwnProperties(Metadata.FaviconRequests);
        return memoryInfo;
    }
    window.onload = function () {
        var info = $("#memory-information");
        info.html("Some numbers:");
        var list = $("<ul>");
        info.append(list);
        var _a = getMemoryInfo(), nRRAllowed = _a.nRRAllowed, nRRDenied = _a.nRRDenied, nRRTotal = _a.nRRTotal, nClickedLinks = _a.nClickedLinks, nFaviconRequests = _a.nFaviconRequests;
        list.append("<li>RequestResult objects: " + nRRTotal + " (" + nRRAllowed + " allowed requests, " + nRRDenied + " denied requests)</li>");
        list.append("<li>Clicked links: " + nClickedLinks + "</li>");
        list.append("<li>Favicon requests: " + nFaviconRequests + "</li>");
    };
    window.freeMemory = function () {
        var results = $("#free-memory-results");
        results.html("<br />Starting to free memory... ");
        var _a = freeMemory(), nRRTotal = _a.nRRTotal, nClickedLinks = _a.nClickedLinks, nFaviconRequests = _a.nFaviconRequests;
        results.append(" DONE.<br />Successfully removed...");
        var list = $("<ul>");
        results.append(list);
        list.append("<li>" + nRRTotal + " RequestResult objects</li>");
        list.append("<li>" + nClickedLinks + " clicked links</li>");
        list.append("<li>" + nFaviconRequests + " favicon requests</li>");
    };
})();