(function () {
    var overlay = window.parent.rpcontinued.overlay;
    var menu = window.parent.rpcontinued.menu;
    var $id = document.getElementById.bind(document);
    $id("rpc-origin").addEventListener("click", menu.itemSelected, false);
    $id("rpc-revoke-temporary-permissions").addEventListener("click", overlay.revokeTemporaryPermissions, false);
    var toggleLinkBlocking = function (event) {
        var disabled = overlay.toggleTemporarilyAllowAll();
        $id("rpc-link-enable-blocking").hidden = !disabled;
        $id("rpc-link-disable-blocking").hidden = disabled;
    };
    $id("rpc-link-enable-blocking").addEventListener("click", toggleLinkBlocking, false);
    $id("rpc-link-disable-blocking").addEventListener("click", toggleLinkBlocking, false);
    $id("rpc-link-help").addEventListener("click", overlay.openHelp, false);
    $id("rpc-link-prefs").addEventListener("click", overlay.openPrefs, false);
    $id("rpc-link-policies").addEventListener("click", overlay.openPolicyManager, false);
    $id("rpc-link-request-log").addEventListener("click", overlay.toggleRequestLog, false);
    if (window !== window.parent) {
        var observer = new MutationObserver(function () {
            var popupframe = window.parent.document.getElementById("rpc-popup-frame");
            if (popupframe) {
                var frameContentDiv = $id("rpc-contents");
                var contentHeight = frameContentDiv.scrollHeight;
                var contentWidth = frameContentDiv.scrollWidth;
                if (contentWidth && contentWidth !== 0) {
                    popupframe.style.width = contentWidth + "px";
                }
                if (contentHeight && contentHeight !== 0) {
                    popupframe.style.height = contentHeight + "px";
                }
            }
        });
        var mutationTarget = $id("rpc-contents");
        var confObserver = {
            attributes: true,
            childList: true,
            characterData: true,
            subtree: true,
        };
        observer.observe(mutationTarget, confObserver);
    }
})();