"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var interface_1 = require("./interface");
var tree_view_1 = require("./tree-view");
var filtering_1 = require("./filtering");
var _a = browser.extension.getBackgroundPage(), Environment = _a.Environment, MainEnvironment = _a.MainEnvironment;
window.rpcontinued = window.rpcontinued || {};
window.rpcontinued.requestLog = window.rpcontinued.requestLog || {};
(function () {
    var requestLog = window.rpcontinued.requestLog;
    var WinEnv = new Environment(MainEnvironment, "WinEnv");
    WinEnv.shutdownOnUnload(window);
    WinEnv.startup();
    var $id = window.document.getElementById.bind(window.document);
    requestLog.isEmptyMessageDisplayed = true;
    requestLog.rows = [];
    requestLog.visibleRows = [];
    function init() {
        requestLog.tree = $id("rpcontinued-requestLog-tree");
        requestLog.tree.view = requestLog.treeView;
        showLogIsEmptyMessage();
        window.parent.rpcontinued.overlay.requestLog = requestLog;
    }
    function showLogIsEmptyMessage() {
        var message = browser.i18n.getMessage("requestLogIsEmpty");
        var directions = browser.i18n.getMessage("requestLogDirections");
        requestLog.visibleRows.push([message, directions, false, ""]);
        requestLog.treebox.rowCountChanged(0, 1);
    }
    WinEnv.elManager.addListener(window, "load", init, false);
    return requestLog;
})();
interface_1.loadRLInterfaceIntoWindow(window);
tree_view_1.loadRLTreeViewIntoWindow(window);
filtering_1.loadRLFilteringIntoWindow(window);