"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function loadRLTreeViewIntoWindow(window) {
    var requestLog = window.rpcontinued.requestLog;
    requestLog.treebox = null;
    requestLog.columnNameToIndexMap = {
        "rpcontinued-requestLog-origin": 0,
        "rpcontinued-requestLog-destination": 1,
        "rpcontinued-requestLog-blocked": 2,
        "rpcontinued-requestLog-time": 3,
    };
    function getVisibleRowAtIndex(index) {
        return requestLog.visibleRows[requestLog.visibleRows.length - index - 1];
    }
    requestLog.treeView = {
        get rowCount() {
            return requestLog.visibleRows.length;
        },
        setTree: function (aTreebox) {
            requestLog.treebox = aTreebox;
        },
        getCellText: function (aIndex, aColumn) {
            var columnIndex = requestLog.columnNameToIndexMap[aColumn.id];
            if (columnIndex !== 2) {
                return getVisibleRowAtIndex(aIndex)[columnIndex];
            }
        },
        isContainer: function (aIndex) {
            return false;
        },
        isContainerOpen: function (aIndex) {
            return false;
        },
        isContainerEmpty: function (aIndex) {
            return false;
        },
        isSeparator: function (aIndex) {
            return false;
        },
        isSorted: function () {
            return false;
        },
        isEditable: function (aIndex, aColumn) {
            return false;
        },
        getParentIndex: function (aIndex) {
            return -1;
        },
        getLevel: function (aIndex) {
            return 0;
        },
        hasNextSibling: function (aIndex, aAfter) {
            return false;
        },
        toggleOpenState: function (aIndex) {
            return;
        },
        getImageSrc: function (aIndex, aColumn) {
            if (requestLog.columnNameToIndexMap[aColumn.id] === 2) {
                if (getVisibleRowAtIndex(aIndex)[2]) {
                    return "chrome://rpcontinued/skin/dot.png";
                }
            }
        },
        getProgressMode: function (aIndex, aColumn) { return; },
        getCellValue: function (aIndex, aColumn) { return; },
        cycleHeader: function (col, elem) { return; },
        selectionChanged: function () { return; },
        cycleCell: function (aIndex, aColumn) { return; },
        performAction: function (action) { return; },
        performActionOnCell: function (action, aIndex, aColumn) { return; },
        getRowProperties: function (aIndex) {
            return getVisibleRowAtIndex(aIndex)[2] ? "blocked" : "allowed";
        },
        getCellProperties: function (aIndex, aColumn) {
            if (requestLog.columnNameToIndexMap[aColumn.id] === 2) {
                if (getVisibleRowAtIndex(aIndex)[2]) {
                    return "blocked";
                }
            }
            return "";
        },
        getColumnProperties: function (aColumn) {
            return "";
        },
    };
}
exports.loadRLTreeViewIntoWindow = loadRLTreeViewIntoWindow;